unit SkinEditor ;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DsgnIntf, ComCtrls, IniFiles, ExtCtrls;

const
  WM_GOTIT = WM_APP + 123;

type
  TSkinEditorProperty = class(TPropertyEditor)
  public
        function GetValue : string;override;
        function GetAttributes: TPropertyAttributes;override;
        procedure Edit;override;
  end;

{ gz }
  TSkinFilenameProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TSkinFormComponentEditor = class(TComponentEditor)
  public
  	procedure Edit; override;
  end;

  TMySkinEditor = class(TForm)
    BtnExit: TButton;
    PageControl: TPageControl;
    BitmapSheet: TTabSheet;
    ButtonSheet: TTabSheet;
    TextSheet: TTabSheet;
    TrackBarSheet: TTabSheet;
    BtnSave: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditMask: TEdit;
    EditMouseUp: TEdit;
    EditMouseOver: TEdit;
    EditMouseDown: TEdit;
    BtnMask: TButton;
    BtnMouseUp: TButton;
    BtnMouseOver: TButton;
    BtnMouseDown: TButton;
    Label5: TLabel;
    EditButtonID: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    EditButtonX: TEdit;
    EditButtonY: TEdit;
    EditButtonW: TEdit;
    EditButtonH: TEdit;
    EditGroupName: TEdit;
    Label10: TLabel;
    ChkSwitchBtn: TCheckBox;
    ChkRadioBtn: TCheckBox;
    ComboInitState: TComboBox;
    Label11: TLabel;
    BtnAddButton: TButton;
    BtnDelButton: TButton;
    EditTextID: TEdit;
    EditTextY: TEdit;
    EditTextX: TEdit;
    EditTextDefault: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    BtnAddText: TButton;
    BtnDelText: TButton;
    BtnChooseFont: TButton;
    LblFontSize: TLabel;
    LblBold: TLabel;
    LblItalic: TLabel;
    LblFontColor: TLabel;
    EditTrackBarID: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    EditTrackBarX: TEdit;
    Label18: TLabel;
    EditTrackBarY: TEdit;
    Label19: TLabel;
    EditTrackBarL: TEdit;
    Label20: TLabel;
    EditTrackBarP: TEdit;
    Label21: TLabel;
    EditTrackBarUp: TEdit;
    BtnTrackBarUp: TButton;
    BtnTrackBarDown: TButton;
    EditTrackBarDown: TEdit;
    Label22: TLabel;
    BtnAddTrackBar: TButton;
    BtnDelTrackBar: TButton;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    LblFontName: TLabel;
    Label28: TLabel;
    ComboCharset: TComboBox;
    BtnLoad: TButton;
    RBtnH: TRadioButton;
    RBtnV: TRadioButton;
    GroupBox1: TGroupBox;
    ListBoxButton: TListBox;
    ListBoxTrackBar: TListBox;
    ListBoxText: TListBox;
    BtnUpdateButton: TButton;
    BtnUpdateText: TButton;
    BtnUpdateTrackBar: TButton;
    Label29: TLabel;
    Label30: TLabel;
    EditText: TEdit;
    EditNumbers: TEdit;
    BtnNumber: TButton;
    BtnText: TButton;
    ComboStyle: TComboBox;
    Label31: TLabel;
    PreView: TButton;
    Pick: TButton;
    EditButtonHint: TEdit;
    Label32: TLabel;
    AddNew: TButton;
    EditTrackBarHint: TEdit;
    Label33: TLabel;
    procedure BtnExitClick(Sender: TObject);
    procedure ChooseFile(Sender: TObject);
    procedure BtnChooseFontClick(Sender: TObject);
    procedure ChkSwitchBtnClick(Sender: TObject);
    procedure ChkRadioBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure BtnAddTextClick(Sender: TObject);
    procedure BtnDelTextClick(Sender: TObject);
    procedure ListBoxTextClick(Sender: TObject);
    procedure BtnAddButtonClick(Sender: TObject);
    procedure BtnDelButtonClick(Sender: TObject);
    procedure BtnAddTrackBarClick(Sender: TObject);
    procedure BtnDelTrackBarClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure ListBoxButtonClick(Sender: TObject);
    procedure ListBoxTrackBarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PreViewClick(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PickClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AddNewClick(Sender: TObject);
  private
    { Private declarations }

    { gz }
    SkinFile: string;
    procedure Load(const Filename : string);
    procedure UpdateHelpPanel(x, y, w, h : integer);
    procedure DisplayHelpPanel;

  public
    { Public declarations }
    Procedure GetTheRect(var Msg:TMessage);message WM_GOTIT;
    function  IsIDAlreadyExist(var List:TListBox;var Edit:TEdit):Boolean;
  end;

var
  MySkinEditor: TMySkinEditor;
  Strs            : TStringList;
  bModified       : Boolean;
  MainBmpPath     : string;
  IniVersion      : Integer;
  EditorVersion   : Integer;
  GetArea,Drag    : Boolean;
  TopLeft,BtmRight: TPoint;
  NewBtnNumber   : Integer;
  NewTxtNumber   : Integer;
  NewTbrNumber   : Integer;
  bAddNew          : Boolean;

implementation

uses SkinForm, PreviewWnd;

{$R *.DFM}

{ gz }
procedure TSkinFilenameProperty.Edit;
var
	FileOpen: TOpenDialog;
begin
     FileOpen := TOpenDialog.Create(Application);
     FileOpen.Filename := GetValue;
     FileOpen.Filter := 'Skin files (*.ini)|*.ini';
     FileOpen.Options := FileOpen.Options + [ofPathMustExist, ofFileMustExist];
     try
        if FileOpen.Execute then SetValue(FileOpen.Filename);
     finally
            FileOpen.Free;
     end;
end;


function TSkinFilenameProperty.GetAttributes: TPropertyAttributes;
begin
     Result := [paDialog, paRevertable];
end;

procedure TSkinEditorProperty.Edit;
var
  SkinEditor : TMySkinEditor;
  FileOpen: TOpenDialog;
begin
     GetArea := FALSE;
     EditorVersion := 150;
     NewBtnNumber := 1;
     NewTxtNumber := 1;
     NewTbrNumber := 1;
     bAddNew := FALSE;
     FileOpen := TOpenDialog.Create(Application);
     FileOpen.Filename := GetValue;
     FileOpen.Filter := 'Skin files (*.ini)|*.ini';
     FileOpen.Options := FileOpen.Options + [ofPathMustExist, ofFileMustExist];

     SkinEditor := TMySkinEditor.Create(Application);
     { gz }
     SkinEditor.SkinFile := (GetComponent(0) as TSkinForm).SkinFile;
     if SkinEditor.SkinFile <> '' then SkinEditor.Load(SkinEditor.SkinFile);
     SkinEditor.ShowModal;
     (GetComponent(0) as TSkinForm).SkinFile := SkinEditor.SkinFile;
     SkinEditor.Free;
     PreForm.Free;
     PreForm := nil;
end;

procedure TSkinFormComponentEditor.Edit;
var
  SkinEditor : TMySkinEditor;
begin
     GetArea := FALSE;
     EditorVersion := 150;
     NewBtnNumber := 1;
     NewTxtNumber := 1;
     NewTbrNumber := 1;
     bAddNew := FALSE;

     SkinEditor := TMySkinEditor.Create(Application);
     { gz }
     SkinEditor.SkinFile :=(Component as TSkinForm).SkinFile;
     if SkinEditor.SkinFile <> '' then SkinEditor.Load(SkinEditor.SkinFile);

     SkinEditor.ShowModal;
     (Component as TSkinForm).SkinFile := SkinEditor.SkinFile;
     SkinEditor.Free;
     PreForm.Free;
     PreForm := nil;
end;


function TSkinEditorProperty.GetValue:string;
begin
     Result := 'Run Editor';
end;

function TSkinEditorProperty.GetAttributes:TPropertyAttributes;
begin
     Result := [paDialog, paReadOnly];
end;


procedure TMySkinEditor.BtnExitClick(Sender: TObject);
begin
     if bModified = TRUE then
     begin
          if Application.MessageBox('Do you want to save the chages ?',
                                    'Save', MB_YESNO) = IDYES then
            BtnSaveClick(self);
     end;
     Close;
end;

procedure TMySkinEditor.ChooseFile(Sender: TObject);
var
   OpenFileDlg: TOpenDialog;
   Name : string;
begin
     OpenFileDlg := TOpenDialog.Create(self);
     OpenFileDlg.Filter :='Bitmap file (*.bmp)|*.BMP|JPEG image file (*.jpg, *.jpeg)|*.JPG;*.JPEG|GIF image file (*.gif)|*.GIF';
     if OpenFileDlg.Execute then
     begin
          Name := TButton(Sender).Name;
          if Name = 'BtnMask' then EditMask.Text := ExtractFileName(OpenFileDlg.FileName)
          else
          if Name = 'BtnMouseUp' then
          begin
            EditMouseUp.Text := ExtractFileName(OpenFileDlg.FileName);
            MainBmpPath :=  ExtractFilePath(OpenFileDlg.FileName);
          end
          else
          if Name = 'BtnMouseOver' then EditMouseOver.Text := ExtractFileName(OpenFileDlg.FileName)
          else
          if Name = 'BtnMouseDown' then EditMouseDown.Text := ExtractFileName(OpenFileDlg.FileName)
          else
          if Name = 'BtnTrackBarUp' then EditTrackBarUp.Text := ExtractFileName(OpenFileDlg.FileName)
          else
          if Name = 'BtnTrackBarDown' then EditTrackBarDown.Text := ExtractFileName(OpenFileDlg.FileName)
          else
          if Name = 'BtnNumber' then EditNumbers.Text := ExtractFileName(OpenFileDlg.FileName)
          else
          if Name = 'BtnText' then EditText.Text := ExtractFileName(OpenFileDlg.FileName);

          bModified := TRUE;
     end;
     OpenFileDlg.Free;
end;

procedure TMySkinEditor.BtnChooseFontClick(Sender: TObject);
var
   FontDlg : TFontDialog;
begin
     FontDlg := TFontDialog.Create(self);
     if FontDlg.Execute then
     begin
          LblFontName.Caption := FontDlg.Font.Name;
          LblFontSize.Caption := IntToStr(FontDlg.Font.Size);
          LblFontColor.Caption := '$00'+Format('%2.2x',[GetBValue(FontDlg.Font.Color)])+
                                  Format('%2.2x',[GetGValue(FontDlg.Font.Color)])+
                                  Format('%2.2x',[GetRValue(FontDlg.Font.Color)]);

          if fsBold in FontDlg.Font.Style then LblBold.Caption := 'TRUE'
          else LblBold.Caption := 'FALSE';
          if fsItalic in FontDlg.Font.Style then LblItalic.Caption := 'TRUE'
          else LblItalic.Caption := 'FALSE';
     end;
     FontDlg.Free;
end;

procedure TMySkinEditor.ChkSwitchBtnClick(Sender: TObject);
begin
     ComboInitState.Enabled := ChkSwitchBtn.Checked;
     Label11.Enabled := ChkSwitchBtn.Checked;
end;

procedure TMySkinEditor.ChkRadioBtnClick(Sender: TObject);
begin
     EditGroupName.Enabled := ChkRadioBtn.Checked;
     Label10.Enabled := ChkRadioBtn.Checked;
end;

procedure TMySkinEditor.FormCreate(Sender: TObject);
begin
     SkinFile := '';
     ComboCharset.ItemIndex := 0;
     ComboInitState.ItemIndex := 0;
     ComboStyle.ItemIndex := 0;

     EditButtonID.Text := 'BUTTON_';
     EditTextID.Text := 'TEXT_';
     EditTrackBarID.Text := 'TRACKBAR_';

     PageControl.ActivePage := BitmapSheet;
     Strs := TStringList.Create;
     bModified := FALSE;
end;

procedure TMySkinEditor.Load(const Filename : string);
var
   SkinFile : TIniFile;
   iLoop, Count,i : integer;
   s : string;
   Charset : integer;
begin
          {Added by Ben Huang}
          if PreForm <> Nil then
          begin
            PreForm.Free;
            PreForm := Nil;
          end;
          SkinFile := TIniFile.Create(Filename);

          IniVersion := SkinFile.ReadInteger('VERSION','Ver',140);
          NewBtnNumber := SkinFile.ReadInteger('NEWIDNUMBER','Button',1);
          NewTxtNumber := SkinFile.ReadInteger('NEWIDNUMBER','Text',1);
          NewTbrNumber := SkinFile.ReadInteger('NEWIDNUMBER','Trackbar',1);

          EditMask.Text := SkinFile.ReadString('BITMAPINFO', 'MaskBitmap', 'ERROR');
          EditMouseUp.Text := SkinFile.ReadString('BITMAPINFO', 'MouseUpBitmap', EditMask.Text);
          EditMouseDown.Text := SkinFile.ReadString('BITMAPINFO', 'MouseDownBitmap', EditMouseUp.Text);
          EditMouseOver.Text := SkinFile.ReadString('BITMAPINFO', 'MouseOnBitmap', EditMouseDown.Text);
          EditNumbers.Text := SkinFile.ReadString('BITMAPINFO', 'NumbersBitmap', '');
          EditText.Text := SkinFile.ReadString('BITMAPINFO', 'TextBitmap', '');

          ListBoxButton.Items.Clear;
          Count := SkinFile.ReadInteger('HOTAREAINFO', 'Count', 0);
          for iLoop := 1 to Count do
          begin
              s := SkinFile.ReadString('HOTAREAINFO', IntToStr(iLoop), 'NOT_DEFINED, 0, 0, 0, 0, hint');
              {Added by Ben Huang}
              if(IniVersion < EditorVersion ) and (EditorVersion = 150) then
              begin{Convert button data of old ini version to that of new version}
                Strs.Clear;
                CommaTextToStrs(Strs, s, ',');
                s := Strs.Strings[0];
                for i := 1 to  Strs.Count-1 do
                begin
                  if i = 4 then
                    s := s + ', '+ Strs.Strings[i]+', '
                  else
                    s := s +', ' + Strs.Strings[i];
                end;
              end;
              ListBoxButton.Items.Add(s);
          end;

          ListBoxText.Items.Clear;
          Count := SkinFile.ReadInteger('DISPLAYINFO', 'Count', 0);
          for iLoop := 1 to Count do
          begin
               s := SkinFile.ReadString('DISPLAYINFO', IntToStr(iLoop), 'NOT_DEFINED, Arial, FALSE, FALSE, 0, $000000, 0, 0');
               ListBoxText.Items.Add(s);
          end;

          ListBoxTrackBar.Items.Clear;
          Count := SkinFile.ReadInteger('TRACKBARINFO', 'Count', 0);
          for iLoop := 1 to Count do
          begin
               s := SkinFile.ReadString('TRACKBARINFO', IntToStr(iLoop), 'NOT_DEFINED, NOT_DEFINED, NOT_DEFINED, 0, 0, 0, H');
               ListBoxTrackBar.Items.Add(s);
          end;
          Charset := SkinFile.ReadInteger('DISPLAYINFO', 'Charset', 1);

          case Charset of

               1: ComboCharset.ItemIndex := 0;

          end;

          SkinFile.Free;
          bModified := FALSE;
end;

procedure TMySkinEditor.BtnLoadClick(Sender: TObject);
var
   OpenFileDlg : TOpenDialog;
begin
     OpenFileDlg := TOpenDialog.Create(self);
     OpenFileDlg.Filter := 'Skin files (*.ini)|*.INI';
     if OpenFileDlg.Execute then
     begin
          SkinFile := OpenFileDlg.FileName;
          Load(OpenFileDlg.FileName);
     end;
     OpenFileDlg.Free;
     PageControl.ActivePage := BitmapSheet;
end;

procedure TMySkinEditor.BtnAddTextClick(Sender: TObject);
var
   s, name : string;
begin
     if EditTextID.Text = '' then
     begin
          ShowMessage('Please Input ID!');
          Exit;
     end;

     try
        StrToInt(EditTextX.Text);
     except
           on EConvertError do EditTextX.Text := '0';
     end;

     try
        StrToInt(EditTextY.Text);
     except
           on EConvertError do EditTextY.Text := '0';
     end;

     s := EditTextID.Text + ', ' + LblFontName.Caption + ', ' +
          LblBold.Caption + ', ' + LblItalic.Caption + ', ' +
          LblFontSize.Caption + ', ' + LblFontColor.Caption + ', ' +
          EditTextX.Text + ', ' + EditTextY.Text + ', '+ ComboStyle.Text;//Ben

     s := s + ', ' + EditTextDefault.Text;

     name := TButton(Sender).Name;
     if (name = 'BtnAddText') or (name = 'AddNew') then
     begin
       if IsIDalreadyExist(ListBoxText,EditTextID)= TRUE then
       begin
          ShowMessage('Current ID has already existed!');
          Exit;
       end;
       ListBoxText.Items.Add(s);
     end;

     if name = 'BtnUpdateText' then
     begin
          if ListBoxText.ItemIndex <> -1 then
             ListBoxText.Items.Strings[ListBoxText.ItemIndex] := s
          else
              ShowMessage('Please Choose a item.');
     end;
     Inc(NewTxtNumber);
     bModified := TRUE;
end;

procedure TMySkinEditor.BtnDelTextClick(Sender: TObject);
var
  iIndex : Integer;
begin
     if ListBoxText.ItemIndex <> -1 then
     begin
          iIndex :=  ListBoxText.ItemIndex ;
          ListBoxText.Items.Delete(ListBoxText.ItemIndex);
          ListBoxText.ItemIndex := iIndex - 1 ;
          bModified := TRUE;
          ListBoxTextClick(ListBoxText);
     end;
     bModified := TRUE;
end;

procedure TMySkinEditor.BtnAddButtonClick(Sender: TObject);
var
   s, name : string;
begin
     if EditButtonID.Text = '' then
     begin
          ShowMessage('Please Input ID!');
          Exit;
     end;

     try
        StrToInt(EditButtonX.Text);
     except
           on EConvertError do EditButtonX.Text := '0';
     end;

     try
        StrToInt(EditButtonY.Text);
     except
           on EConvertError do EditButtonY.Text := '0';
     end;

     try
        StrToInt(EditButtonW.Text);
     except
           on EConvertError do EditButtonW.Text := '0';
     end;

     try
        StrToInt(EditButtonH.Text);
     except
           on EConvertError do EditButtonH.Text := '0';
     end;
     {Added by Ben Huang}
     if EditButtonHint.Text = '' then
     begin
         EditButtonHint.Text := ' ';
     end;

     if  ChkRadioBtn.Checked then
     begin
          if EditGroupName.Text = '' then
          begin
               ShowMessage('Please input group name!');
               Exit;
          end;
     end;

     s := EditButtonID.Text + ', ' + EditButtonX.Text + ', ' +
          EditButtonY.Text + ', ' + EditButtonW.Text + ', ' +
          EditButtonH.Text + ', ' + EditButtonHint.Text{Ben};

     if ChkSwitchBtn.Checked then s := s + ', ' + ComboInitState.Text;
     if ChkRadioBtn.Checked then s := s + ', ' + EditGroupName.Text;

     name := TButton(Sender).Name;

     if (name = 'BtnAddButton') or  (name = 'Addnew') then
     begin
     if IsIDalreadyExist(ListBoxButton,EditButtonID)= TRUE then
        begin
           ShowMessage('Current ID has already existed!');
           Exit;
        end;
        ListBoxButton.Items.Add(s);
     end;

     if name = 'BtnUpdateButton' then
     begin
          if ListBoxButton.ItemIndex <> -1 then
             ListBoxButton.Items.Strings[ListBoxButton.ItemIndex] := s
          else
              ShowMessage('Please Choose a item.');
     end;
     Inc(NewBtnNumber);
     bModified := TRUE;
end;

procedure TMySkinEditor.BtnDelButtonClick(Sender: TObject);
var
  iIndex:Integer;
begin
     if ListBoxButton.ItemIndex <> -1 then
     begin
          iIndex :=  ListBoxButton.ItemIndex ;
          ListBoxButton.Items.Delete(ListBoxButton.ItemIndex);
          ListBoxButton.ItemIndex := iIndex - 1 ;
          ListBoxButtonClick(ListBoxButton);
          bModified := TRUE;
     end;
end;

procedure TMySkinEditor.BtnAddTrackBarClick(Sender: TObject);
var
   s, st, name : string;
begin
     if EditTrackBarID.Text = '' then
     begin
          ShowMessage('Please Input ID!');
          Exit;
     end;

     try
        StrToInt(EditTrackBarX.Text);
     except
           on EConvertError do EditTrackBarX.Text := '0';
     end;

     try
        StrToInt(EditTrackBarY.Text);
     except
           on EConvertError do EditTrackBarY.Text := '0';
     end;

     try
        StrToInt(EditTrackBarL.Text);
     except
           on EConvertError do EditTrackBarL.Text := '0';
     end;

     try
        StrToInt(EditTrackBarP.Text);
     except
           on EConvertError do EditTrackBarP.Text := '0';
     end;

     if EditTrackBarUp.Text = '' then
     begin
          ShowMessage('Please choose bitmap of trackbar!');
          Exit;
     end;

     if EditTrackBarDown.Text = '' then
        EditTrackBarDown.Text := EditTrackBarUp.Text;

     if RBtnH.Checked then st := 'H';
     if RBtnV.Checked then st := 'V';

     s := EditTrackBarID.Text + ', ' + EditTrackBarUp.Text + ', ' +
          EditTrackBarDown.Text + ', ' + EditTrackBarX.Text + ', ' +
          EditTrackBarY.Text + ', ' + EditTrackBarL.Text + ', ' +
          st + ', ' + EditTrackBarP.Text + ', ' + EditTrackBarHint.Text;


     name := TButton(Sender).Name;
     if (name = 'BtnAddTrackBar') or (name = 'AddNew') then
     begin
       if IsIDalreadyExist(ListBoxTrackBar,EditTrackBarID)= TRUE then
         begin
          ShowMessage('Current ID has already existed!');
          Exit;
       end;
       ListBoxTrackBar.Items.Add(s);
     end;

     if name = 'BtnUpdateTrackBar' then
     begin
        if ListBoxTrackBar.ItemIndex <> -1 then
           ListBoxTrackBar.Items.Strings[ListBoxTrackBar.ItemIndex] := s
        else
           ShowMessage('Please Choose a item.');
     end;
     Inc(NewTbrNumber);
     bModified := TRUE;
end;

procedure TMySkinEditor.BtnDelTrackBarClick(Sender: TObject);
var
  iIndex : Integer;
begin
     if ListBoxTrackBar.ItemIndex <> -1 then
     begin
          iIndex :=  ListBoxTrackBar.ItemIndex ;
          ListBoxTrackBar.Items.Delete(ListBoxTrackBar.ItemIndex);
          ListBoxTrackBar.ItemIndex := iIndex - 1 ;
          ListBoxTrackBarClick(ListBoxTrackBar);
          bModified := TRUE;
     end;
end;

procedure TMySkinEditor.BtnSaveClick(Sender: TObject);
var
   SaveDlg : TSaveDialog;
   SaveFile : TIniFile;
   Charset, Count, iLoop : integer;
begin
     if SkinFile = '' then
     begin
          SaveDlg := TSaveDialog.Create(self);
          if SaveDlg.Execute then
             SkinFile := SaveDlg.FileName;
     end;

     if SkinFile <> '' then
     begin

          SaveFile := TiniFile.Create(SkinFile);

          SaveFile.EraseSection('VERSION');
          SaveFile.EraseSection('NEWIDNUMBER');
          SaveFile.EraseSection('BITMAPINFO');
          SaveFile.EraseSection('HOTAREAINFO');
          SaveFile.EraseSection('DISPLAYINFO');
          SaveFile.EraseSection('TRACKBARINFO');
          {Added by Benjamin Huang}
          SaveFile.WriteInteger('VERSION','Ver',EditorVersion);
          SaveFile.WriteInteger('NEWIDNUMBER','Button',NewBtnNumber);
          SaveFile.WriteInteger('NEWIDNUMBER','Text',NewTxtNumber);
          SaveFile.WriteInteger('NEWIDNUMBER','Trackbar',NewTbrNumber);

          SaveFile.WriteString('BITMAPINFO', 'MaskBitmap', EditMask.Text);
          SaveFile.WriteString('BITMAPINFO', 'MouseUpBitmap', EditMouseUp.Text);
          SaveFile.WriteString('BITMAPINFO', 'MouseDownBitmap', EditMouseDown.Text);
          SaveFile.WriteString('BITMAPINFO', 'MouseOnBitmap', EditMouseOver.Text);
          SaveFile.WriteString('BITMAPINFO', 'NumbersBitmap', EditNumbers.Text);
          SaveFile.WriteString('BITMAPINFO', 'TextBitmap', EditText.Text);

          Count := ListBoxButton.Items.Count;
          SaveFile.WriteString('HOTAREAINFO', 'Count', IntToStr(Count));
          for iLoop := 1 to Count  do
          begin
               SaveFile.WriteString('HOTAREAINFO', IntToStr(iLoop), ListBoxButton.Items.Strings[iLoop-1]);
          end;

          Count := ListBoxText.Items.Count;

          Charset := 1;

          case ComboCharset.ItemIndex of
               0:  Charset := 1;
          end;

          SaveFile.WriteInteger('DISPLAYINFO', 'Charset', Charset);
          SaveFile.WriteString('DISPLAYINFO', 'Count', IntToStr(Count));
          for iLoop := 1 to Count do
          begin
               SaveFile.WriteString('DISPLAYINFO', IntToStr(iLoop), ListBoxText.Items.Strings[iLoop-1]);
          end;

          Count := ListBoxTrackBar.Items.Count;
          SaveFile.WriteString('TRACKBARINFO', 'Count', IntToStr(Count));
          for iLoop := 1 to Count do
          begin
               SaveFile.WriteString('TRACKBARINFO', IntToStr(iLoop), ListBoxTrackBar.Items.Strings[iLoop-1]);
          end;

          SaveFile.Free;
          bModified := FALSE;
     end;
end;

procedure TMySkinEditor.ListBoxButtonClick(Sender: TObject);
var
   s : string;
//   StrCount:Integer;
begin
     if ListBoxButton.ItemIndex <> -1 then
     begin
          s := ListBoxButton.Items.Strings[ListBoxButton.ItemIndex];
          Strs.Clear;
          CommaTextToStrs(Strs, s, ',');
          EditButtonID.Text := Strs.Strings[0];
          EditButtonX.Text := Strs.Strings[1];
          EditButtonY.Text := Strs.Strings[2];
          EditButtonW.Text := Strs.Strings[3];
          EditButtonH.Text := Strs.Strings[4];
          EditButtonHint.Text := Strs.Strings[5];

          UpdateHelpPanel(StrToInt(EditButtonX.Text),StrToInt(EditButtonY.Text),
                          StrToInt(EditButtonW.Text),StrToInt(EditButtonH.Text));

          if Strs.Count >= 7 then
          begin
               ChkSwitchBtn.Checked := TRUE;
               ComboInitState.Text := Strs.Strings[6];
          end
          else
          begin
               ChkSwitchBtn.Checked := FALSE;
               ComboInitState.Enabled := FALSE;
          end;

          if Strs.Count = 8 then
          begin
               ChkRadioBtn.Checked := TRUE;
               EditGroupName.Text := Strs.Strings[7];
          end
          else
          begin
               ChkRadioBtn.Checked := FALSE;
               EditGroupName.Enabled := FALSE;
          end;
     end;
end;

procedure TMySkinEditor.ListBoxTextClick(Sender: TObject);
var
   s : string;
begin
     if ListBoxText.ItemIndex <> -1 then
     begin
          s := ListBoxText.Items.Strings[ListBoxText.ItemIndex];
          Strs.Clear;
          CommaTextToStrs(Strs, s, ',');
          EditTextID.Text := Strs.Strings[0];
          LblFontName.Caption := Strs.Strings[1];
          LblBold.Caption := Strs.Strings[2];
          LblItalic.Caption := Strs.Strings[3];
          LblFontSize.Caption := Strs.Strings[4];
          LblFontColor.Caption := Strs.Strings[5];
          EditTextX.Text := Strs.Strings[6];
          EditTextY.Text := Strs.Strings[7];
          UpdateHelpPanel(StrToInt(EditTextX.Text), StrToInt(EditTextY.Text), 8, 8);
          if Strs.Count >= 9 then
          begin
               if Strs.Strings[8] = 'Number' then ComboStyle.ItemIndex := 1
               else
               if Strs.Strings[8] = 'Text' then ComboStyle.ItemIndex := 2
               else ComboStyle.ItemIndex := 0;
          end;
          if Strs.Count >= 10 then EditTextDefault.Text := Strs.Strings[9]
          else EditTextDefault.Text := '';
     end;
end;

procedure TMySkinEditor.ListBoxTrackBarClick(Sender: TObject);
var
   s : string;
begin
     if ListBoxTrackBar.ItemIndex <> -1 then
     begin
          s := ListBoxTrackBar.Items.Strings[ListBoxTrackBar.ItemIndex];
          Strs.Clear;
          CommaTextToStrs(Strs, s, ',');
          EditTrackBarID.Text := Strs.Strings[0];
          EditTrackBarUp.Text := Strs.Strings[1];
          EditTrackBarDown.Text := Strs.Strings[2];

          EditTrackBarX.Text := Strs.Strings[3];
          EditTrackBarY.Text := Strs.Strings[4];
          EditTrackBarL.Text := Strs.Strings[5];

          if Strs.Strings[6] = 'V' then
             RBtnV.Checked := TRUE
          else
              RBtnH.Checked := TRUE;

          if not RBtnH.Checked then
             UpdateHelpPanel(StrToInt(EditTrackBarX.Text),StrToInt(EditTrackBarY.Text),
                             8,StrToInt(EditTrackBarL.Text))
          else
             UpdateHelpPanel(StrToInt(EditTrackBarX.Text),StrToInt(EditTrackBarY.Text),
                             StrToInt(EditTrackBarL.Text),8);

          if Strs.Count >= 8 then EditTrackBarP.Text := Strs.Strings[7];
          if Strs.Count = 9 then EditTrackBarHint.Text := Strs.Strings[8]
          else EditTrackBarHint.Text := '';

     end;
end;

procedure TMySkinEditor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     Strs.Free;
end;

procedure TMySkinEditor.PreViewClick(Sender: TObject);
begin
    if SkinFile <> '' then
    begin
      IniFile := SkinFile;
      PreForm.Free;
      PreForm := nil;
      if(PreForm = nil ) then
        PreForm := TPreviewWnd.Create(Application);
      PreForm.Show;
      DisplayHelpPanel;
    end else
      MessageDlg('Please save ini file first!',mtInformation,[mbOk], 0);
end;

procedure TMySkinEditor.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  temp:Integer;
  TheDC:HDC;
//  Pt:TPoint;
begin
	if  Drag  then
  begin
 	  // Erase last rectangle.
		Drag := FALSE;
		GetArea := FALSE;
		ReleaseCapture();
		TheDC := CreateDC ('DISPLAY', Nil, Nil, Nil );
		SetROP2(TheDC, R2_NOTXORPEN );
		Rectangle (TheDC, TopLeft.x, TopLeft.y, BtmRight.x, BtmRight.y );
    DeleteDC(TheDC);

		if(TopLeft.x>BtmRight.x) then
    begin
			temp := TopLeft.x;
			TopLeft.x := BtmRight.x;
			BtmRight.x := temp;
    End;
		if(TopLeft.y>BtmRight.y) then
    begin
			temp := TopLeft.y;
			TopLeft.y := BtmRight.y;
			BtmRight.y := temp;
    end;

    TopLeft := PreForm.ScreenToClient(TopLeft);
    BtmRight := PreForm.ScreenToClient(BtmRight);

    if PageControl.ActivePage = ButtonSheet then
    Begin
      EditButtonX.Text := IntToStr(TopLeft.X);
      EditButtonY.Text := IntToStr(TopLeft.Y);
      EditButtonW.Text := IntToStr(BtmRight.X-TopLeft.X);
      EditButtonH.Text := IntToStr(BtmRight.Y-TopLeft.Y);
      if bAddNew  then
      begin
        //if IsIDAlreadyExist(ListBoxButton,EditButtonID) = FALSE then
        begin
         EditButtonID.Text := 'BUTTON_' + IntToStr(NewBtnNumber);
         BtnAddButtonClick(BtnAddButton);
        end;
      end;
    end else
    if PageControl.ActivePage = TextSheet then
    Begin
      EditTextX.Text := IntToStr(TopLeft.X);
      EditTextY.Text := IntToStr(TopLeft.Y);
//    EditButtonW.Text := IntToStr(BtmRight.X-TopLeft.X);
//    EditButtonH.Text := IntToStr(BtmRight.Y-TopLeft.Y);
      if bAddNew then
      begin
      //if IsIDAlreadyExist(ListBoxText,EditTextID) = FALSE then
        begin
          EditTextID.Text := 'TEXT_' + IntToStr(NewTxtNumber);
          BtnAddTextClick(BtnAddText);
        end;
      end;
    end else
    if PageControl.ActivePage = TrackBarSheet then
    Begin
       EditTrackBarX.Text := IntToStr(TopLeft.X);
       EditTrackBarY.Text := IntToStr(TopLeft.Y);
       EditTrackBarL.Text := IntToStr(BtmRight.X-TopLeft.X);
       EditTrackBarP.Text := '0';//IntToStr(BtmRight.Y-TopLeft.Y);
       if bAddNew then
       begin
//         if IsIDAlreadyExist(ListBoxTrackBar,EditTrackbarID) = FALSE then
         begin
            EditTrackbarID.Text := 'TRACKBAR_' + IntToStr(NewTbrNumber);
            BtnAddTrackBarClick(BtnAddTrackBar);
         end;
       end;
    end;
    Caption := 'Skin Editor';
  End;
  bAddNew := False;
  SetCursor(Screen.Cursors[crDefault]);
end;

procedure TMySkinEditor.PickClick(Sender: TObject);
begin
    if SkinFile <> '' then
    begin
      SetCapture(Handle);
      PreViewClick(Sender);
      GetArea := TRUE;
      SetCursor(Screen.Cursors[crCross]);
    end else
      MessageDlg('Please save ini file first!',mtInformation,[mbOk], 0);
end;

procedure TMySkinEditor.PageControlChange(Sender: TObject);
begin
  if PageControl.ActivePage = BitmapSheet  then
  begin
    Pick.Enabled := FALSE;
    Addnew.Enabled := FALSE;
  end
  else
  begin
    Pick.Enabled := TRUE;
    Addnew.Enabled := TRUE;
    DisplayHelpPanel;    
  end;

end;

Procedure TMySkinEditor.GetTheRect(var Msg:TMessage);
begin
  ;
end;

procedure TMySkinEditor.FormMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  TheDc:HDC;
  Pt:TPoint;
begin
  Pt.x := X;
  Pt.y := Y;
	if Drag and (ssLeft in Shift) then
  begin
      TheDc := CreateDC ('DISPLAY', Nil, Nil, Nil );
      SetROP2(TheDc, R2_NOTXORPEN );
      Rectangle ( TheDc,TopLeft.x, TopLeft.y, BtmRight.x,BtmRight.y );
      BtmRight := ClientToScreen(Pt);
      // Draw the new rectangle
      Rectangle(TheDC,TopLeft.x, TopLeft.y, BtmRight.x, BtmRight.y );
      DeleteDC(TheDc);
  end;
  if GetArea Then
  begin
      BtmRight := ClientToScreen(Pt);
      Pt := PreForm.ScreenToClient(BtmRight);
      Caption := 'Skin Editor [Cursor Position:'
              + intToStr(Pt.x) + ',' + IntToStr(Pt.Y) + ']';
  end;
end;
procedure TMySkinEditor.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  pt:TPoint;
begin
    if not GetArea then
   		ReleaseCapture()
    else
    begin
      pt.x := X;
      pt.Y := Y;
      TopLeft := ClientToScreen(pt);
      pt.x := X;
      pt.Y := Y;
      BtmRight := ClientToScreen(pt);
      Drag := TRUE;
    end ;
end;

function TMySkinEditor.IsIdAlreadyExist(var List:TListBox;var Edit:TEdit):Boolean;
var
  Txt:String;
  Idx,iFind,i:Integer;
begin
      Result := FALSE;
      for idx := 0 to List.Items.Count-1 do
      begin
        iFind := Pos(',',List.Items.Strings[idx]);
        if iFind > 0 then
        begin
          SetLength(Txt,iFind-1);
          for i:=1 to iFind-1 do
            Txt[i] := List.Items.Strings[Idx][i];
          if Edit.Text = Txt then
          begin
            Result := TRUE;
            Exit;
          end
        end
      end;
end;

procedure TMySkinEditor.AddNewClick(Sender: TObject);
begin
  bAddNew := TRUE;
  PickClick(Sender);
end;


procedure TMySkinEditor.UpdateHelpPanel(x, y, w, h : integer);
begin
     if PreForm <> nil then
     begin
          PreForm.HelpPanel.Left := x;
          PreForm.HelpPanel.Top :=  y;
          PreForm.HelpPanel.Width :=  w;
          PreForm.HelpPanel.Height := h;
          PreForm.HelpPanel.Visible := TRUE;
     end;
end;

procedure TMySkinEditor.DisplayHelpPanel;
begin
     if PreForm <> nil then PreForm.HelpPanel.Visible := FALSE;
     if PageControl.ActivePage = ButtonSheet then ListBoxButtonClick(self);
     if PageControl.ActivePage = TextSheet then ListBoxTextClick(self);
     if PageControl.ActivePage = TrackBarSheet then ListBoxTrackBarClick(self);
end;
end.
