{
 -------------------------------------------------------------------------------
                 SkinForm Component v1.5 for Delphi 3 and 4

               Copyright 1999 FriendSoft All Rights Reserved.

                        http://friendsoft.yeah.net

 From v1.4, this component is not FREE, although you have got all of it and
 needn't pay anything. The reason is my girl friend. I met her one year ago in
 Beijing and then went to Japan for my new job in Tokyo. I promised her that I
 would telephone her every month. However, recently I busied with myself updating
 this component, I forgot to call her and didn't replied her letter untill I have
 finished this version, but she did. Although she said that she could understand,
 I am really regretful for it, so I want to give her a gift, a special gift. She
 is a college student in Beijing, studying foreign culture,  a stamp collector.
 I think that maybe you would like to help me, if you think this  component is
 helpful for you, would you like to send me some stamps or postcards of your
 country? Photograph of your country's landscape is also acceptable.

 If you would like to do, my address is at the bottom of this source file.

 This component can be freely used and distributed in commercial and private
 products, if you like it, please drop me an e-mail and send your screenshots.

 Please feel free to contact me if you have any comments or suggestions.

 Author: Xue Huai Qing [xhq@writeme.com]

 Credits:
   Thanks to Ben Huang (Huangbili) & Gerd Zanker for changes and ideas of visual design
   Some functions come from Jscalco & Eddie Shipman, many thanks to them.
   Thanks to Anders Melander [http://www.melander.dk] for his GREAT COMPONENT ---- TGIFImage
   Thanks to Andre Inghillieri for his improvements of text display support.
   Thanks to Konrad Swart for his .dcr file and encouragement.
   Thanks to Daaron Dwyer (ddwyer@ncic.com) for his job of radio button support.
   Tanks to Scott Jarkoff [http://www.cybertropix.com] for his advice.
   Thanks to all people who give me a lot of encouragement and suggestions.

 Description:
 ============
   Are you bored by Windows95 UI? Do you want to create an application which
 has a cool and changeable UI just like WPlay and WinAmp?
   If so, SkinForm might be the thing that you want. This component can help
 you to change the visual appearance of your project and make non-rectangular
 windows forms quite easily.

 Usage:
 ======
   1.Make the skins of your applications, they are must be in bitmap format.

   2.Make a skin file just like the skin file in the demo. The file format is
     described in the readme and it can be generated by the embedded-editor.

   3.Use LoadSkinFile to load a skin file.

   4.Add your own code to catch the following events:
     OnMouseDownNotify, OnMouseMoveNotify, OnMouseUpNotify, OnTrackBarNotify

 History:
 ========
        1.00    Initial release

        1.01    Clean the code and make it compatible with Delphi 3

        1.10    Add functions to manage the information of dispaly area
                Reduce the action of refresh
                Add an OnSkinChanged event

        1.20    Add support of trackbar
                Fixed bugs of displaying text
                Reduce the fliker time

        1.30    Fixed some bugs and make trackbar moving more smoothly
                Add support of Radio Button
                Add functions to manage the ID of HotArea
                Add OnTrackBarNotify event
                Add an embedded-editor

        1.40    Add support of .jpeg, .gif file
                Add support of graphic text
                Add support of graohic numbers

        1.41    Add SetTrackBarPos method

        1.50    Add Function to avoid duplicate ID
                Add preview support at design time
                Add support of visual design
                Add SetTrackBarMinMax method
                Add Hint support to button and trackbar
                Add internal support of Skins

 ------------------------------------------------------------------------------}
unit SkinForm;

{$R-}

//if you use Delphi 3, please add "{$DEFINE DELPHI3}" as a new line

{$DEFINE GIFSUPPORT}
//if you don't want to get support of GIF, please remove the line above.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, IniFiles, StdCtrls, DsgnIntf, Jpeg;

const
{$IFDEF DELPHI3}
     MAX_HOTAREA = 127;
     MAX_DISPLAYAREA = 63;
     MAX_TRACKBAR = 15;
{$ENDIF}
     NumbersString : string = '0123456789 ';
     TextStringRow1 : string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ@"?*';
     TextStringRow2 : string = '0123456789 .:<>-''!_+\/[]^&%,=$';
     TextStringRow3 : string = 'abcdefghijklmnopqrstuvwxyz';
     CurVersion : integer = 150;
type

  TMouseDownNotify = Procedure (ID : string; Button: TMouseButton; Shift: TShiftState; X, Y: Integer) of object;
  TMouseUpNotify = Procedure (ID : string; Button: TMouseButton; Shift: TShiftState; X, Y: Integer) of object;
  TMouseMoveNotify = Procedure (ID : string; Shift: TShiftState; X, Y: Integer) of object;
  TTrackBarNotify = Procedure (ID : string; Position : integer) of object;

  HotAreaInfoRec = record
                 ID : string;
                 x, y : integer;
                 Width, Height : integer;
                 bLockable, bSwitchOn : Boolean;
                 RadioGroup : string;
                 Hint:string;
                 Down:Boolean;
                 end;
  DisplayInfoRec = record
                 ID : string;
                 x, y :integer;
                 Font : TFont;
                 Style : string;
                 Text : string;
                 end;

  TrackBarInfoRec = record
                  ID : string;
                  UpBitmap, DownBitmap : TBitmap;
                  x, y, Length : integer;
                  Direction : Boolean;
                  Position : 0..100;
                  Offset : integer;
                  width, height : integer;
                  Hint:string;
                  Min, Max : 0..100;
                  end;
  {$IFDEF DELPHI3}
  BITMAP = record
         bmType : longint;
         bmWidth : longint;
         bmHeight : longint;
         bmWidthBytes : longint;
         bmPlanes : WORD;
         bmBitsPixel : WORD;
         bmBits : pointer;
         end;
  THotAreaInfoArray = array [0..MAX_HOTAREA] of HotAreaInfoRec;
  TDisplayInfoArray = array [0..MAX_DISPLAYAREA] of DisplayInfoRec;
  TTrackBarInfoArray = array [0..MAX_TRACKBAR] of TrackBarInfoRec;
  {$ELSE}
  THotAreaInfoArray = array of HotAreaInfoRec;
  TDisplayInfoArray = array of DisplayInfoRec;
  TTrackBarInfoArray = array of TrackBarInfoRec;
  {$ENDIF}

  TSkinForm = class(TImage)
  private
    { Private declarations }
    FMaskBitmap : TBitmap;
    FMouseUpBitmap : TBitmap;
    FMouseOnBitmap: TBitmap;
    FMouseDownBitmap : TBitmap;

    FNumbersBitmap : TBitmap;
    FTextBitmap : TBitmap;

    FRegion : HRGN;
    FKeyColor : TColor;
    FTolerance : TColor;
    FHotAreaInfoArray : THotAreaInfoArray;
    FDisplayInfoArray : TDisplayInfoArray;
    FTrackBarInfoArray : TTrackBarInfoArray;

    FEnableMouseOnBitmap : Boolean;
    FClassID : string;
    FCharset : TFontCharset;

    FbNeedRedraw : Boolean;

    FbLastState, FbThisState : Boolean;

    FOnMouseDownNotify : TMouseDownNotify;
    FOnMouseUpNotify : TMouseUpNotify;
    FOnMouseMoveNotify : TMouseMoveNotify;
    FOnTrackBarNotify : TTrackBarNotify;
    FOnSkinChanged : TNotifyEvent;

    FRadios : TStringList;
    FRadioSel : TStringList;

    FSkinFile: string;

    {$IFDEF DELPHI3}
    FHotAreaCount : integer;
    FDisplayCount : integer;
    FTrackBarCount : integer;
    {$ENDIF}

    bInHotArea : Boolean;

    bDragTrackBar : Boolean;
    iDragTrackBar : integer;
    iDragTrackBarOffset : integer;
    FVersion :Integer;
  protected
    { Protected declarations }
    procedure HandleRadio(i : integer);
    procedure LoadBitmapFile(var Bitmap : TBitmap; const FileName : string);
    procedure LoadBitmapRes(var Bitmap : TBitmap; const ResName : string);
    procedure SetParent(Value:TWinControl);override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer);override;

    procedure JPEG2Bitmap(var Bitmap : TBitmap; const JPEGFileName : string);
    procedure JPEG2BitmapRes(var Bitmap : TBitmap; const JPEGResName : string);
    {$IFDEF GIFSUPPORT}
    procedure GIF2Bitmap(var Bitmap : TBitmap; const GIFFileName : string);
    procedure GIF2BitmapRes(var Bitmap : TBitmap; const GIFResName : string);
    {$ENDIF}
    procedure BMP2BitmapRes(var Bitmap : TBitmap; const BMPResName : string);
    procedure WriteNumbersString(X, Y : integer; const Str : string);
    procedure WriteTextString(X, Y : integer; const Str : string);
    procedure InitSkin;
    procedure ValidateTrackBar(var Trackbar : TrackBarInfoRec);
    procedure ShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
  public
    { Public declarations }
    constructor Create(Aowner:TComponent); override;
    destructor Destroy; override;
    procedure SetKeyColor(KeyColor : TColor);
    procedure SetTolerance(Tolerance : TColor);
    procedure LoadSkinFile(const Skin : string);
    procedure LoadDefaultSkin;
    procedure MouseDownNotify(ID : string; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MouseUpNotify(ID : string; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MouseMoveNotify(ID : string; Shift: TShiftState; X, Y: Integer);
    procedure TrackBarNotify(ID : string; Position : integer);
    procedure Refresh;
    function  GetHotAreaState(ID : string) : Boolean;
    procedure SetCharset(Charset : TFontCharset);
    procedure SetDisplayText(ID : string; Text : string);
    function  GetTrackBarPos(ID : string) : integer;
    procedure SetTrackBarPos(ID : string; Value : integer);
    procedure SetTrackBarMinMax(ID : string; Min, Max : integer);
    procedure SetHotAreaState(ID : string; state : Boolean);
    function  IDToNumber(ID : string) : integer;
    function  NumberToID(Index : integer) : string;
    procedure SetSkinEditor(Value : string);
    function  GetSkinEditor : string;
    procedure SetSkinFile(const Value: string);

  published
    { Published declarations }
    property KeyColor : TColor
             read FKeyColor
             write SetKeyColor;

    property Tolerance : TColor
             read FTolerance
             write SetTolerance;

    property OnMouseDownNotify : TMouseDownNotify
             read FOnMouseDownNotify
             write FOnMouseDownNotify;

    property OnMouseUpNotify : TMouseUpNotify
             read FOnMouseUpNotify
             write FOnMouseUpNotify;

    property OnMouseMoveNotify : TMouseMoveNotify
             read FOnMouseMoveNotify
             write FOnMouseMoveNotify;

    property OnTrackBarNotify : TTrackBarNotify
             read  FOnTrackBarNotify
             write FOnTrackBarNotify;

    property OnSkinChanged :TNotifyEvent
             read FOnSkinChanged
             write FOnSkinChanged;

    property SkinEditor : string
             read GetSkinEditor
             write SetSkinEditor;

    property SkinFile : string
             read FSkinFile
             write SetSkinFile;
  end;

function MinByte(B1, B2: byte): byte;
function Bitmap2Region( hBmp: TBitmap; TransColor: TColor; Tolerance: TColor): HRGN;
procedure CommaTextToStrs( AStrs: TStrings; const Value: string ; const AchDelim : Char );
function GetExtendName(str : string) : string;
function GetName(str : string) : string;

procedure Register;

implementation

uses SkinEditor
{$IFDEF GIFSUPPORT}
,GifImage
{$ENDIF};

constructor TSkinForm.Create(Aowner : TComponent);
begin
     inherited Create(Aowner);
     FMaskBitmap := TBitmap.Create;
     FMouseUpBitmap := TBitmap.Create;
     FMouseOnBitmap := TBitmap.Create;
     FMouseDownBitmap := TBitmap.Create;
     FNumbersBitmap := TBitmap.Create;
     FTextBitmap := TBitmap.Create;
     Align := alClient;
     FKeyColor := clWhite;
     FTolerance := $00000000;
     FRegion := 0;
     FEnableMouseOnBitmap := TRUE;
     FCharset := DEFAULT_CHARSET;
     FbNeedRedraw := TRUE;
     FRadios := TStringList.Create;
     FRadiosel := TStringList.Create;
     FVersion := CurVersion;
     Application.OnShowHint := self.ShowHint;
     FSkinFile :='';
end;

destructor TSkinForm.Destroy;
var
i : integer;
begin
     FMaskBitmap.Free;
     FMouseUpBitmap.Free;
     FMouseOnBitmap.Free;
     FMouseDownBitmap.Free;
     FNumbersBitmap.Free;
     FTextBitmap.Free;
     {$IFDEF DELPHI3}
     for i := 0 to FTrackBarCount - 1 do
     {$ELSE}
     for i := 0 to Length(FTrackBarInfoArray) - 1 do
     {$ENDIF}
     begin
          FTrackBarInfoArray[i].UpBitmap.Free;
          FTrackBarInfoArray[i].DownBitmap.Free;
     end;

     {$IFDEF DELPHI3}
     for i := 0 to FDisplayCount - 1 do
     {$ELSE}
     for i := 0 to Length(FDisplayInfoArray) - 1 do
     {$ENDIF}
     begin
          FDisplayInfoArray[i].Font.Free;
     end;

     {$IFNDEF DELPHI3}
     SetLength(FHotAreaInfoArray, 0);
     SetLength(FDisplayInfoArray, 0);
     SetLength(FTrackBarInfoArray, 0);
     {$ENDIF}
     FRadios.Free;
     FRadioSel.Free;
     Inherited Destroy;
end;

procedure TSkinForm.SetParent(Value : TWinControl);
begin
     inherited SetParent(Value);
     if Value<>nil then
        if (Value is TForm) then
           TForm(Value).BorderStyle:=bsNone
        else
   	    raise Exception.Create('Please Drop on a Form')
end;

procedure TSkinForm.SetKeyColor(KeyColor : TColor);
begin
     if FKeyColor <> KeyColor then FKeyColor := KeyColor;
end;

procedure TSkinForm.SetTolerance(Tolerance : TColor);
begin
     if FTolerance <> Tolerance then FTolerance := Tolerance;
end;

procedure TSkinForm.LoadBitmapFile(var Bitmap : TBitmap; const FileName : string);
var
   Ext : string;
begin
     if Bitmap = nil then Bitmap := TBitmap.Create;

     Ext := GetExtendName(ExtractFileName(FileName));

     if Ext = 'GIF' then
     begin
          {$IFDEF GIFSUPPORT}
          GIF2Bitmap(Bitmap, FileName);
          {$ELSE}
          ShowMessage('Please enable GIF support!');
          {$ENDIF}
     end
     else
         JPEG2Bitmap(Bitmap, FileName);
end;

procedure TSkinForm.LoadBitmapRes(var Bitmap : TBitmap; const ResName : string);
var
   Res, TypeName : string;
begin
     if Bitmap = nil then Bitmap := TBitmap.Create;

     TypeName := GetExtendName(ResName);
     Res := GetName(ResName);

     if TypeName = 'GIF' then
     begin
          {$IFDEF GIFSUPPORT}
          GIF2BitmapRes(Bitmap, Res);
          {$ELSE}
          ShowMessage('Please enable GIF support!');
          {$ENDIF}
     end;

     if TypeName = 'BMP' then
        BMP2BitmapRes(Bitmap, Res)
     else
         JPEG2BitmapRes(Bitmap, Res);
end;

procedure TSkinForm.LoadSkinFile(const Skin : string);
var
   SkinFile : TIniFile;
   Count, iLoop : integer;
   s : string;
   Strs : TStringList;
   strMask, strMouseUp, strMouseOn, strMouseDown : string;
   strNumbers, strText : string;
   BitmapPath : string;
   RadioIndex : integer;
   strCount : integer;
begin
     Align := alClient;
     FRegion := 0;
     FEnableMouseOnBitmap := TRUE;
     BitmapPath := ExtractFilePath(Skin);
     SkinFile := TIniFile.Create(Skin);
     FVersion :=SkinFile.ReadInteger('Version','Ver',140);
     strMask := SkinFile.ReadString('BITMAPINFO', 'MaskBitmap', 'ERROR');
     strMouseUp := SkinFile.ReadString('BITMAPINFO', 'MouseUpBitmap', strMask);
     strMouseDown := SkinFile.ReadString('BITMAPINFO', 'MouseDownBitmap', strMouseUp);
     strMouseOn := SkinFile.ReadString('BITMAPINFO', 'MouseOnBitmap', strMouseDown);
     strNumbers := SkinFile.ReadString('BITMAPINFO', 'NumbersBitmap', '');
     strText := SkinFile.ReadString('BITMAPINFO', 'TextBitmap', '');

     if strMouseOn = strMouseDown then FEnableMouseOnBitmap := FALSE;

     strMask := BitmapPath + strMask;
     strMouseUp := BitmapPath + strMouseUp;
     strMouseDown := BitmapPath + strMouseDown;
     strMouseOn := BitmapPath + strMouseOn;

     if strNumbers <> '' then strNumbers := BitmapPath + strNumbers;
     if strText <> '' then strText := BitmapPath + strText;
     StrCount := 0;
     Count := SkinFile.ReadInteger('HOTAREAINFO', 'Count', 0);
     {$IFDEF DELPHI3}
     FHotAreaCount := Count;
     {$ELSE}
     SetLength(FHotAreaInfoArray, Count);
     {$ENDIF}
     Strs := TStringList.Create;

     LoadBitmapFile(FMaskBitmap, strMask);
     LoadBitmapFile(FMouseUpBitmap, strMouseUp);
     LoadBitmapFile(FMouseOnBitmap, strMouseOn);
     LoadBitmapFile(FMouseDownBitmap, strMouseDown);

     InitSkin;

     if strNumbers <> '' then LoadBitmapFile(FNumbersBitmap, strNumbers);
     if strText <> '' then LoadBitmapFile(FTextBitmap, strText);

     for iLoop := 1 to Count do
     begin
          Strs.Clear;
          s := SkinFile.ReadString('HOTAREAINFO', IntToStr(iLoop), 'NOT_DEFINED, 0, 0, 0, 0');
          CommaTextToStrs(Strs, s, ',');
          FHotAreaInfoArray[iLoop-1].ID := Strs.Strings[0];
          FHotAreaInfoArray[iLoop-1].x := StrToInt(Strs.Strings[1]);
          FHotAreaInfoArray[iLoop-1].y := StrToInt(Strs.Strings[2]);
          FHotAreaInfoArray[iLoop-1].Width := StrToInt(Strs.Strings[3]);
          FHotAreaInfoArray[iLoop-1].Height := StrToInt(Strs.Strings[4]);
          FHotAreaInfoArray[iLoop-1].bLockable := FALSE;
          FHotAreaInfoArray[iLoop-1].RadioGroup := '';
          FHotAreaInfoArray[iLoop-1].Down := FALSE;
          FHotAreaInfoArray[iLoop-1].Hint := '';

          {Modified by Ben Huang}
          if FVersion = 150 then
          begin
            StrCount := 7;
            FHotAreaInfoArray[iLoop-1].Hint := Strs.Strings[5];
          end
          else if  FVersion = 140 then
            StrCount := 6;
          if Strs.Count >= StrCount then
          begin
               FHotAreaInfoArray[iLoop-1].bLockable := TRUE;
               if Strs.Strings[StrCount-1] = 'FALSE' then
                  FHotAreaInfoArray[iLoop-1].bSwitchOn := FALSE
               else
                  FHotAreaInfoArray[iLoop-1].bSwitchOn := TRUE;
          end;
          if Strs.Count = (StrCount+1) then
          begin
               RadioIndex := FRadios.IndexOf(Strs.Strings[StrCount]);
               if RadioIndex = -1 then begin
                  // radio group not found, add it
                  RadioIndex := FRadios.Count;
                  FRadios.Add(Strs.Strings[StrCount]);
                  FRadioSel.Add('-1');
               end;
               FHotAreaInfoArray[iLoop-1].RadioGroup := Strs.Strings[StrCount];
               if FHotAreaInfoArray[iLoop-1].bSwitchOn = TRUE then
                     fRadioSel.Strings[RadioIndex] := IntToStr(iLoop-1);
               FHotAreaInfoArray[iLoop-1].bLockable := TRUE;
          end;

     end;
     /////////////////
     Count := SkinFile.ReadInteger('DISPLAYINFO', 'Count', 0);
     FCharset := SkinFile.ReadInteger('DISPLAYINFO', 'Charset', DEFAULT_CHARSET);
     {$IFDEF DELPHI3}
     FDisplayCount := Count;
     {$ELSE}
     SetLength(FDisplayInfoArray, Count);
     {$ENDIF}
     for iLoop := 1 to Count do
     begin
          Strs.Clear;
          s := SkinFile.ReadString('DISPLAYINFO', IntToStr(iLoop), 'NOT_DEFINED, Arial, FALSE, FALSE, 0, $000000, 0, 0');
          CommaTextToStrs(Strs, s, ',');
          FDisplayInfoArray[iLoop-1].ID := Strs.Strings[0];

          if FDisplayInfoArray[iLoop-1].Font <> nil then FDisplayInfoArray[iLoop-1].Font.Free;

          FDisplayInfoArray[iLoop-1].Font := TFont.Create;

          with FDisplayInfoArray[iLoop-1] do
          begin
               Font.Charset := FCharset;
               Font.Name := Strs.Strings[1];
               Font.Style := [];

               if Strs.Strings[2] = 'TRUE' then
                  Font.Style := Font.Style + [fsBold];

               if Strs.Strings[3] = 'TRUE' then
                  Font.Style := Font.Style + [fsItalic];

               Font.Size := StrToInt(Strs.Strings[4]);
               Font.Color := StrToInt(Strs.Strings[5]);
               x := StrToInt(Strs.Strings[6]);
               y := StrToInt(Strs.Strings[7]);
               if Strs.Count >= 9 then Style := Strs.Strings[8];
               if Strs.Count = 10 then
                  Text := Strs.Strings[9]
               else
                   Text := '';

          end;
     end;

     ///////////////
     Count := SkinFile.ReadInteger('TRACKBARINFO', 'Count', 0);
     {$IFDEF DELPHI3}
     FTrackBarCount := Count;
     {$ELSE}
     SetLength(FTrackBarInfoArray, Count);
     {$ENDIF}
     for iLoop := 1 to Count do
     begin
          Strs.Clear;
          s := SkinFile.ReadString('TRACKBARINFO', IntToStr(iLoop), 'NOT_DEFINED, NOT_DEFINED, NOT_DEFINED, 0, 0, 0, H');
          CommaTextToStrs(Strs, s, ',');
          FTrackBarInfoArray[iLoop-1].ID := Strs.Strings[0];

          LoadBitmapFile(FTrackBarInfoArray[iLoop-1].UpBitmap, BitmapPath + Strs.Strings[1]);
          LoadBitmapFile(FTrackBarInfoArray[iLoop-1].DownBitmap, BitmapPath + Strs.Strings[2]);

          FTrackBarInfoArray[iLoop-1].Width := FTrackBarInfoArray[iLoop-1].DownBitmap.Width;
          FTrackBarInfoArray[iLoop-1].Height := FTrackBarInfoArray[iLoop-1].DownBitmap.Height;

          FTrackBarInfoArray[iLoop-1].x := StrToInt(Strs.Strings[3]);
          FTrackBarInfoArray[iLoop-1].y := StrToInt(Strs.Strings[4]);
          FTrackBarInfoArray[iLoop-1].Length := StrToInt(Strs.Strings[5]);

          FTrackBarInfoArray[iLoop-1].Min := 0;
          FTrackBarInfoArray[iLoop-1].Max := 100;

          if Strs.Strings[6] = 'V' then
             FTrackBarInfoArray[iLoop-1].Direction := FALSE
          else
              FTrackBarInfoArray[iLoop-1].Direction := TRUE;

          if Strs.Count >= 8 then
             FTrackBarInfoArray[iLoop-1].Position := StrToInt(Strs.Strings[7])
          else
              FTrackBarInfoArray[iLoop-1].Position := 0;

          FTrackBarInfoArray[iLoop-1].Hint := '';
          if Strs.Count >= 9 then
             FTrackBarInfoArray[iLoop-1].Hint := Strs.Strings[8];

          if FTrackBarInfoArray[iLoop-1].Direction = TRUE then
             FTrackBarInfoArray[iLoop-1].Offset := FTrackBarInfoArray[iLoop-1].Position * (FTrackBarInfoArray[iLoop-1].Length - FTrackBarInfoArray[iLoop-1].Width) div 100
          else
              FTrackBarInfoArray[iLoop-1].Offset := FTrackBarInfoArray[iLoop-1].Position * (FTrackBarInfoArray[iLoop-1].Length- FTrackBarInfoArray[iLoop-1].Height) div 100;
     end;
     Strs.Free;
     SkinFile.Free;
     iDragTrackBar := -1;
     Refresh;
     if Assigned(FOnSkinChanged) then FOnSkinChanged(Self);
end;

procedure TSkinForm.InitSkin;
begin
     Parent.Width := FMaskBitmap.Width;
     Parent.Height := FMaskBitmap.Height;
     Parent.ClientWidth := FMaskBitmap.Width;
     Parent.ClientHeight := FMaskBitmap.Height;
     Picture := nil;
     Width := FMaskBitmap.Width;
     Height := FMaskBitmap.Height;

     FRegion := Bitmap2Region(FMaskBitmap, FKeyColor, FTolerance);
     SetWindowRgn(Parent.Handle, FRegion, TRUE);
     Refresh;
end;

procedure TSkinForm.LoadDefaultSkin;
var
   SkinFile : TIniFile;
   Count, iLoop : integer;
   s : string;
   Strs : TStringList;
   strMask, strMouseUp, strMouseOn, strMouseDown : string;
   strNumbers, strText : string;
   RadioIndex : integer;
   strCount : integer;
   ResStream : TResourceStream;
   Skin : string;
begin
     Align := alClient;
     FRegion := 0;
     FEnableMouseOnBitmap := TRUE;

     ResStream := TResourceStream.Create(hInstance, 'skin', 'INI');
     Skin := ExtractFilePath(Application.ExeName) + 'skin.ini';
     ResStream.SaveToFile(Skin);
     ResStream.Free;

     SkinFile := TIniFile.Create(Skin);
     FVersion :=SkinFile.ReadInteger('Version','Ver',140);
     strMask := SkinFile.ReadString('BITMAPINFO', 'MaskBitmap', 'ERROR');
     strMouseUp := SkinFile.ReadString('BITMAPINFO', 'MouseUpBitmap', strMask);
     strMouseDown := SkinFile.ReadString('BITMAPINFO', 'MouseDownBitmap', strMouseUp);
     strMouseOn := SkinFile.ReadString('BITMAPINFO', 'MouseOnBitmap', strMouseDown);
     strNumbers := SkinFile.ReadString('BITMAPINFO', 'NumbersBitmap', '');
     strText := SkinFile.ReadString('BITMAPINFO', 'TextBitmap', '');

     if strMouseOn = strMouseDown then FEnableMouseOnBitmap := FALSE;

     StrCount := 0;
     Count := SkinFile.ReadInteger('HOTAREAINFO', 'Count', 0);
     {$IFDEF DELPHI3}
     FHotAreaCount := Count;
     {$ELSE}
     SetLength(FHotAreaInfoArray, Count);
     {$ENDIF}
     Strs := TStringList.Create;

     LoadBitmapRes(FMaskBitmap, strMask);
     LoadBitmapRes(FMouseUpBitmap, strMouseUp);
     LoadBitmapRes(FMouseOnBitmap, strMouseOn);
     LoadBitmapRes(FMouseDownBitmap, strMouseDown);

     InitSkin;

     if strNumbers <> '' then LoadBitmapRes(FNumbersBitmap, strNumbers);
     if strText <> '' then LoadBitmapRes(FTextBitmap, strText);

     for iLoop := 1 to Count do
     begin
          Strs.Clear;
          s := SkinFile.ReadString('HOTAREAINFO', IntToStr(iLoop), 'NOT_DEFINED, 0, 0, 0, 0');
          CommaTextToStrs(Strs, s, ',');
          FHotAreaInfoArray[iLoop-1].ID := Strs.Strings[0];
          FHotAreaInfoArray[iLoop-1].x := StrToInt(Strs.Strings[1]);
          FHotAreaInfoArray[iLoop-1].y := StrToInt(Strs.Strings[2]);
          FHotAreaInfoArray[iLoop-1].Width := StrToInt(Strs.Strings[3]);
          FHotAreaInfoArray[iLoop-1].Height := StrToInt(Strs.Strings[4]);
          FHotAreaInfoArray[iLoop-1].bLockable := FALSE;
          FHotAreaInfoArray[iLoop-1].RadioGroup := '';
          FHotAreaInfoArray[iLoop-1].Down := FALSE;
          FHotAreaInfoArray[iLoop-1].Hint := '';

          {Modified by Ben Huang}
          if FVersion = 150 then
          begin
            StrCount := 7;
            FHotAreaInfoArray[iLoop-1].Hint := Strs.Strings[5];
          end
          else if  FVersion = 140 then
            StrCount := 6;
          if Strs.Count >= StrCount then
          begin
               FHotAreaInfoArray[iLoop-1].bLockable := TRUE;
               if Strs.Strings[StrCount-1] = 'FALSE' then
                  FHotAreaInfoArray[iLoop-1].bSwitchOn := FALSE
               else
                  FHotAreaInfoArray[iLoop-1].bSwitchOn := TRUE;
          end;
          if Strs.Count = (StrCount+1) then
          begin
               RadioIndex := FRadios.IndexOf(Strs.Strings[StrCount]);
               if RadioIndex = -1 then begin
                  // radio group not found, add it
                  RadioIndex := FRadios.Count;
                  FRadios.Add(Strs.Strings[StrCount]);
                  FRadioSel.Add('-1');
               end;
               FHotAreaInfoArray[iLoop-1].RadioGroup := Strs.Strings[StrCount];
               if FHotAreaInfoArray[iLoop-1].bSwitchOn = TRUE then
                     fRadioSel.Strings[RadioIndex] := IntToStr(iLoop-1);
               FHotAreaInfoArray[iLoop-1].bLockable := TRUE;
          end;

     end;
     /////////////////
     Count := SkinFile.ReadInteger('DISPLAYINFO', 'Count', 0);
     FCharset := SkinFile.ReadInteger('DISPLAYINFO', 'Charset', DEFAULT_CHARSET);
     {$IFDEF DELPHI3}
     FDisplayCount := Count;
     {$ELSE}
     SetLength(FDisplayInfoArray, Count);
     {$ENDIF}
     for iLoop := 1 to Count do
     begin
          Strs.Clear;
          s := SkinFile.ReadString('DISPLAYINFO', IntToStr(iLoop), 'NOT_DEFINED, Arial, FALSE, FALSE, 0, $000000, 0, 0');
          CommaTextToStrs(Strs, s, ',');
          FDisplayInfoArray[iLoop-1].ID := Strs.Strings[0];

          if FDisplayInfoArray[iLoop-1].Font <> nil then FDisplayInfoArray[iLoop-1].Font.Free;

          FDisplayInfoArray[iLoop-1].Font := TFont.Create;

          with FDisplayInfoArray[iLoop-1] do
          begin
               Font.Charset := FCharset;
               Font.Name := Strs.Strings[1];
               Font.Style := [];

               if Strs.Strings[2] = 'TRUE' then
                  Font.Style := Font.Style + [fsBold];

               if Strs.Strings[3] = 'TRUE' then
                  Font.Style := Font.Style + [fsItalic];

               Font.Size := StrToInt(Strs.Strings[4]);
               Font.Color := StrToInt(Strs.Strings[5]);
               x := StrToInt(Strs.Strings[6]);
               y := StrToInt(Strs.Strings[7]);
               if Strs.Count >= 9 then Style := Strs.Strings[8];
               if Strs.Count = 10 then
                  Text := Strs.Strings[9]
               else
                   Text := '';

          end;
     end;

     ///////////////
     Count := SkinFile.ReadInteger('TRACKBARINFO', 'Count', 0);
     {$IFDEF DELPHI3}
     FTrackBarCount := Count;
     {$ELSE}
     SetLength(FTrackBarInfoArray, Count);
     {$ENDIF}
     for iLoop := 1 to Count do
     begin
          Strs.Clear;
          s := SkinFile.ReadString('TRACKBARINFO', IntToStr(iLoop), 'NOT_DEFINED, NOT_DEFINED, NOT_DEFINED, 0, 0, 0, H');
          CommaTextToStrs(Strs, s, ',');
          FTrackBarInfoArray[iLoop-1].ID := Strs.Strings[0];

          LoadBitmapRes(FTrackBarInfoArray[iLoop-1].UpBitmap, Strs.Strings[1]);
          LoadBitmapRes(FTrackBarInfoArray[iLoop-1].DownBitmap, Strs.Strings[2]);

          FTrackBarInfoArray[iLoop-1].Width := FTrackBarInfoArray[iLoop-1].DownBitmap.Width;
          FTrackBarInfoArray[iLoop-1].Height := FTrackBarInfoArray[iLoop-1].DownBitmap.Height;

          FTrackBarInfoArray[iLoop-1].x := StrToInt(Strs.Strings[3]);
          FTrackBarInfoArray[iLoop-1].y := StrToInt(Strs.Strings[4]);
          FTrackBarInfoArray[iLoop-1].Length := StrToInt(Strs.Strings[5]);

          FTrackBarInfoArray[iLoop-1].Min := 0;
          FTrackBarInfoArray[iLoop-1].Max := 100;

          if Strs.Strings[6] = 'V' then
             FTrackBarInfoArray[iLoop-1].Direction := FALSE
          else
              FTrackBarInfoArray[iLoop-1].Direction := TRUE;

          if Strs.Count >= 8 then
             FTrackBarInfoArray[iLoop-1].Position := StrToInt(Strs.Strings[7])
          else
              FTrackBarInfoArray[iLoop-1].Position := 0;

          FTrackBarInfoArray[iLoop-1].Hint := '';
          if Strs.Count >= 9 then
             FTrackBarInfoArray[iLoop-1].Hint := Strs.Strings[8];

          if FTrackBarInfoArray[iLoop-1].Direction = TRUE then
             FTrackBarInfoArray[iLoop-1].Offset := FTrackBarInfoArray[iLoop-1].Position * (FTrackBarInfoArray[iLoop-1].Length - FTrackBarInfoArray[iLoop-1].Width) div 100
          else
              FTrackBarInfoArray[iLoop-1].Offset := FTrackBarInfoArray[iLoop-1].Position * (FTrackBarInfoArray[iLoop-1].Length- FTrackBarInfoArray[iLoop-1].Height) div 100;
     end;
     Strs.Free;
     SkinFile.Free;
     iDragTrackBar := -1;
     Refresh;
     DeleteFile(Skin);
end;

procedure TSkinForm.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   i : integer;
begin
     FClassID := '';
     bInHotArea := FALSE;
     bDragTrackBar := FALSE;
     iDragTrackBar := -1;
     If Button = mbLeft then
     begin
          {$IFDEF DELPHI3}
          for i := 0 to FHotAreaCount - 1 do
          {$ELSE}
          for i := 0 to Length(FHotAreaInfoArray) - 1 do
          {$ENDIF}
          begin
               if PtInRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                FHotAreaInfoArray[i].x + FHotAreaInfoArray[i].Width,
                                FHotAreaInfoArray[i].y + FHotAreaInfoArray[i].Height),
                           Point(X, Y)) then
               begin
                    Canvas.CopyRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                         FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height),
                                         FMouseDownBitmap.Canvas,
                                    Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                         FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height));
                    bInHotArea := TRUE;
                    FHotAreaInfoArray[i].Down := TRUE;
                    FClassID := FHotAreaInfoArray[i].ID;

                    if FHotAreaInfoArray[i].RadioGroup <> '' then HandleRadio(i);

                    if FHotAreaInfoArray[i].bLockable then
                    begin
                       FHotAreaInfoArray[i].bSwitchOn := not FHotAreaInfoArray[i].bSwitchOn;

                    if FHotAreaInfoArray[i].bSwitchOn then
                       Canvas.CopyRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                            FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height),
                                            FMouseDownBitmap.Canvas,
                                       Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                            FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height))
                    else
                       Canvas.CopyRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                            FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height),
                                            FMouseUpBitmap.Canvas,
                                       Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                            FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height));
                    end;
                    break;
               end;
          end;

          ///////////////
          {$IFDEF DELPHI3}
          for i := 0 to FTrackBarCount - 1 do
          {$ELSE}
          for i := 0 to Length(FTrackBarInfoArray) - 1 do
          {$ENDIF}
          begin
               if FTrackBarInfoArray[i].Direction = TRUE then
               begin
                    if PtInRect(Rect(FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Offset,
                                     FTrackBarInfoArray[i].y,
                                     FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Offset + FTrackBarInfoArray[i].Width,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Height),
                                Point(X, Y)) then
                    begin
                         FClassID := FTrackBarInfoArray[i].ID;
                         bDragTrackBar := TRUE;
                         iDragTrackBar := i;
                         iDragTrackBarOffset := X - FTrackBarInfoArray[i].x- FTrackBarInfoArray[i].Offset;
                         break;
                    end
                    else
                    if PtInRect(Rect(FTrackBarInfoArray[i].x, FTrackBarInfoArray[i].y,
                                     FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Length, // - FTrackBarInfoArray[i].Width,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Height),
                                Point(X, Y)) then
                    begin
                         FClassID := FTrackBarInfoArray[i].ID;
                         FTrackBarInfoArray[i].Offset := X - FTrackBarInfoArray[i].x - FTrackBarInfoArray[i].width div 2;
                         if FTrackBarInfoArray[i].Offset < 0 then
                            FTrackBarInfoArray[i].Offset := 0;
                         if FTrackBarInfoArray[i].Offset > FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width then
                            FTrackBarInfoArray[i].Offset := FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width;
                         FTrackBarInfoArray[i].Position := FTrackBarInfoArray[i].Offset *100 div (FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width);
                         ValidateTrackBar(FTrackBarInfoArray[i]);
                         TrackBarNotify(FClassID, FTrackBarInfoArray[i].Position);
                         Refresh;
                         break;
                    end;
               end
               else
               begin
                    if PtInRect(Rect(FTrackBarInfoArray[i].x,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Offset,
                                     FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Width,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Offset + FTrackBarInfoArray[i].Height),
                                Point(X, Y)) then
                    begin
                         FClassID := FTrackBarInfoArray[i].ID;
                         bDragTrackBar := TRUE;
                         iDragTrackBar := i;
                         iDragTrackBarOffset := Y - FTrackBarInfoArray[i].y - FTrackBarInfoArray[i].Offset;
                         break;
                    end
                    else
                    if PtInRect(Rect(FTrackBarInfoArray[i].x, FTrackBarInfoArray[i].y,
                                     FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Width,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Height),
                                Point(X, Y)) then
                    begin
                         FClassID := FTrackBarInfoArray[i].ID;
                         FTrackBarInfoArray[i].Offset := Y - FTrackBarInfoArray[i].y - FTrackBarInfoArray[i].Height div 2;
                         if FTrackBarInfoArray[i].Offset < 0 then
                            FTrackBarInfoArray[i].Offset := 0;
                         if FTrackBarInfoArray[i].Offset > Y - FTrackBarInfoArray[i].y - FTrackBarInfoArray[i].Height then
                             FTrackBarInfoArray[i].Offset := Y - FTrackBarInfoArray[i].y - FTrackBarInfoArray[i].Height;
                         FTrackBarInfoArray[i].Position := FTrackBarInfoArray[i].Offset *100 div (FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Height);
                         ValidateTrackBar(FTrackBarInfoArray[i]);                         
                         TrackBarNotify(FClassID, FTrackBarInfoArray[i].Position);
                         Refresh;
                         break;
                    end;
               end;
          end;
     end;

     If ((Button = mbLeft) and (bInHotArea = FALSE) and (bDragTrackBar = FALSE)) then
     begin
          ReleaseCapture;
	  TWincontrol (Parent).Perform (WM_SYSCOMMAND, SC_MOVE or HTCAPTION, 0);
     end;

     MouseDownNotify(FClassID, Button, Shift, X, Y);
end;

procedure TSkinForm.MouseMove(Shift: TShiftState; X, Y: Integer);
var
   i : integer;
begin

     if FbNeedRedraw then Refresh;

     Hint := '';

     FbLastState := FbThisState;

     FClassID := '';

     if bDragTrackBar = TRUE then
     begin
          {$IFDEF DELPHI3}
          for i := 0 to FTrackBarCount - 1 do
          {$ELSE}
          for i := 0 to Length(FTrackBarInfoArray) - 1 do
          {$ENDIF}
          begin
               if FTrackBarInfoArray[i].Direction = TRUE then
               begin
                    if ((X >= FTrackBarInfoArray[i].x) and
                    (X <= FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Length)) then
                    begin
                         if  iDragTrackBar = i then
                         begin
                              FClassID := FTrackBarInfoArray[i].ID;
                              FTrackBarInfoArray[i].Offset := X - FTrackBarInfoArray[i].x - iDragTrackBarOffset;

                              if FTrackBarInfoArray[i].Offset > FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width
                              then FTrackBarInfoArray[i].Offset := FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width;
                              if FTrackBarInfoArray[i].Offset < 0 then  FTrackBarInfoArray[i].Offset := 0;
                              FTrackBarInfoArray[i].Position := FTrackBarInfoArray[i].Offset *100 div (FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width);
                              ValidateTrackBar(FTrackBarInfoArray[i]);
                              TrackBarNotify(FClassID, FTrackBarInfoArray[i].Position);
                              Refresh;
                         end;
                    end;
               end
               else
               begin
                    if ((Y >= FTrackBarInfoArray[i].y) and
                    (Y <= FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Length)) then
                    begin
                         if  iDragTrackBar = i then
                         begin
                              FClassID := FTrackBarInfoArray[i].ID;
                              FTrackBarInfoArray[i].Offset := Y-FTrackBarInfoArray[i].y;
                              if FTrackBarInfoArray[i].Offset > FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Height
                              then FTrackBarInfoArray[i].Offset := FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Height;
                              FTrackBarInfoArray[i].Position := FTrackBarInfoArray[i].Offset *100 div (FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Height);
                              ValidateTrackBar(FTrackBarInfoArray[i]);                              
                              TrackBarNotify(FClassID, FTrackBarInfoArray[i].Position);
                              Refresh;
                         end;
                    end;
               end;

          end;
     end
     else
     begin
          {$IFDEF DELPHI3}
          for i := 0 to FTrackBarCount - 1 do
          {$ELSE}
          for i := 0 to Length(FTrackBarInfoArray) - 1 do
          {$ENDIF}
          begin
               if FTrackBarInfoArray[i].Direction = TRUE then
               begin
                    if PtInRect(Rect(FTrackBarInfoArray[i].x,FTrackBarInfoArray[i].y,
                                     FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Length,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Height),
                                Point(X, Y)) then
                    Hint := FTrackBarInfoArray[i].Hint;
               end
               else
               begin
                    if PtInRect(Rect(FTrackBarInfoArray[i].x,FTrackBarInfoArray[i].y,
                                     FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Width,
                                     FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Length),
                                Point(X, Y)) then
                    Hint := FTrackBarInfoArray[i].Hint;
               end;
          end;
     end;

     {$IFDEF DELPHI3}
     for i := 0 to FHotAreaCount - 1 do
     {$ELSE}
     for i := 0 to Length(FHotAreaInfoArray) - 1 do
     {$ENDIF}
     begin
          if PtInRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                           FHotAreaInfoArray[i].x + FHotAreaInfoArray[i].Width,
                           FHotAreaInfoArray[i].y + FHotAreaInfoArray[i].Height),
                      Point(X, Y)) then
          begin
               FbThisState := TRUE;
               FClassID := FHotAreaInfoArray[i].ID;
               if FEnableMouseOnBitmap = TRUE then
                  Canvas.CopyRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                       FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height),
                                       FMouseOnBitmap.Canvas,
                                  Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                       FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height));
               Hint := FHotAreaInfoArray[i].Hint;
               break;
          end
          else begin
            if FHotAreaInfoArray[i].Down = TRUE then
               FHotAreaInfoArray[i].Down := False ;
          end;
          FbThisState := FALSE;
     end;

     if FbLastState <> FbThisState then FbNeedRedraw := TRUE;
     MouseMoveNotify(FClassID, Shift, X, Y);
     inherited;
end;

procedure TSkinForm.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   i : integer;
begin
     FClassID := '';
     bInHotArea := FALSE;
     bDragTrackBar := FALSE;
     iDragTrackBar := -1;
     {$IFDEF DELPHI3}
     for i := 0 to FHotAreaCount - 1 do
     {$ELSE}
     for i := 0 to Length(FHotAreaInfoArray) - 1 do
     {$ENDIF}
     begin
          if PtInRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                           FHotAreaInfoArray[i].x + FHotAreaInfoArray[i].Width,
                           FHotAreaInfoArray[i].y + FHotAreaInfoArray[i].Height),
                      Point(X, Y)) then
          begin
               FClassID := FHotAreaInfoArray[i].ID;
               FHotAreaInfoArray[i].Down := False;
               break;
          end;
     end;
     Refresh;
     MouseUpNotify(FClassID, Button, Shift, X, Y);
end;


procedure TSkinForm.Refresh;
var
   i, old: integer;
begin
     Canvas.Draw(0, 0, FMouseUpBitmap);
     {$IFDEF DELPHI3}
     for i := 0 to FHotAreaCount - 1 do
     {$ELSE}
     for i := 0 to Length(FHotAreaInfoArray) - 1 do
     {$ENDIF}
     begin
          if FHotAreaInfoArray[i].bLockable
            and FHotAreaInfoArray[i].bSwitchOn
              or FHotAreaInfoArray[i].Down then
          begin
                  Canvas.CopyRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                       FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height),
                                       FMouseDownBitmap.Canvas,
                                  Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                                       FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height));
          end;
     end;
     {$IFDEF DELPHI3}
     for i := 0 to FTrackBarCount - 1 do
     {$ELSE}
     for i := 0 to Length(FTrackBarInfoArray) - 1 do
     {$ENDIF}
     begin
          if FTrackBarInfoArray[i].Direction = TRUE then
          begin
               if i = iDragTrackBar then
                  Canvas.Draw(FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Offset, FTrackBarInfoArray[i].y, FTrackBarInfoArray[i].DownBitmap)
               else
                   Canvas.Draw(FTrackBarInfoArray[i].x + FTrackBarInfoArray[i].Offset, FTrackBarInfoArray[i].y, FTrackBarInfoArray[i].UpBitmap);
          end
          else
          begin
               if i = iDragTrackBar then
                  Canvas.Draw(FTrackBarInfoArray[i].x , FTrackBarInfoArray[i].y + FTrackBarInfoArray[i].Offset, FTrackBarInfoArray[i].DownBitmap)
               else
                   Canvas.Draw(FTrackBarInfoArray[i].x , FTrackBarInfoArray[i].y+ FTrackBarInfoArray[i].Offset, FTrackBarInfoArray[i].UpBitmap);
          end;

     end;

     {$IFDEF DELPHI3}
     for i := 0 to FDisplayCount - 1 do
     {$ELSE}
     for i := 0 to Length(FDisplayInfoArray) - 1 do
     {$ENDIF}
     begin
          if FDisplayInfoArray[i].Style = 'Number' then
          begin
               WriteNumbersString(FDisplayInfoArray[i].x, FDisplayInfoArray[i].y, FDisplayInfoArray[i].Text);
          end
          else
          if FDisplayInfoArray[i].Style = 'Text' then
          begin
               WriteTextString(FDisplayInfoArray[i].x, FDisplayInfoArray[i].y, FDisplayInfoArray[i].Text);
          end
          else
          begin
               old := GetBkMode(Canvas.Handle);
               SetBkMode(Canvas.Handle,1);
               Canvas.Font.Assign(FDisplayInfoArray[i].Font);
               Canvas.Textout(FDisplayInfoArray[i].x, FDisplayInfoArray[i].y, FDisplayInfoArray[i].Text);
               SetBkMode(Canvas.Handle,old);
          end;

     end;

     FbNeedRedraw := FALSE;
end;

procedure TSkinForm.MouseDownNotify(ID : string; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if assigned(FOnMouseDownNotify) then FOnMouseDownNotify(ID, Button, Shift, X, Y);
end;
procedure TSkinForm.MouseUpNotify(ID : string; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if assigned(FOnMouseUpNotify) then FOnMouseUpNotify(ID, Button, Shift, X, Y);
end;
procedure TSkinForm.MouseMoveNotify(ID : string; Shift: TShiftState; X, Y: Integer);
begin
     if assigned(FOnMouseMoveNotify) then FOnMouseMoveNotify(ID, Shift, X, Y);
end;
procedure TSkinForm.TrackBarNotify(ID : string; Position : integer);
begin
     if assigned(FOnTrackBarNotify) then FOnTrackBarNotify(ID, Position);
end;

{ Added by Daaron Dwyer }
procedure TSkinForm.HandleRadio(i : integer);
var
   groupIdx : integer;
   oldSel : integer;
begin
     groupIdx := fRadios.IndexOf(FHotAreaInfoArray[i].radioGroup);
     if groupIdx = -1 then Exit;
     oldSel := strToInt(fRadioSel.Strings[groupIdx]);
     fRadioSel.Strings[groupIdx] := IntToStr(i);
     if oldSel = -1 then Exit
     else SetHotAreaState(NumberToID(oldSel),FALSE);

     Canvas.CopyRect(Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                     FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height),
                     FMouseUpBitmap.Canvas, Rect(FHotAreaInfoArray[i].x, FHotAreaInfoArray[i].y,
                     FHotAreaInfoArray[i].x+FHotAreaInfoArray[i].Width, FHotAreaInfoArray[i].y+FHotAreaInfoArray[i].Height));
end;

{ Added by Daaron Dwyer }
function TSkinForm.IDToNumber(ID : string) : Integer;
var
   i : integer;
begin
     Result := -1;
     {$IFDEF DELPHI3}
     for i := 0 to FHotAreaCount - 1 do
     {$ELSE}
     for i := 0 to Length(FHotAreaInfoArray) - 1 do
     {$ENDIF}
     begin
          if FHotAreaInfoArray[i].ID = ID then
          begin
               result := i;
               break;
          end;
     end;
end;

{ Added by Daaron Dwyer }
function TSkinForm.NumberToID(Index : integer) : string;
begin
     try
        Result := FHotAreaInfoArray[index].ID;
     except
        Result := '';
     end;
end;

{ Added by Daaron Dwyer }
procedure TSkinForm.SetHotAreaState(ID : string; state : Boolean);
var
   i : integer;
begin
     i := IDToNumber(ID);
     if i <> -1 then begin
        FHotAreaInfoArray[i].bSwitchOn := state;
        Refresh;
     end;
end;

function TSkinForm.GetHotAreaState(ID : string) : Boolean;
var
   i : integer;
begin
     result := FALSE;
     {$IFDEF DELPHI3}
     for i := 0 to FHotAreaCount - 1 do
     {$ELSE}
     for i := 0 to Length(FHotAreaInfoArray) - 1 do
     {$ENDIF}
     begin
          if FHotAreaInfoArray[i].ID = ID then
          begin
               result := FHotAreaInfoArray[i].bSwitchOn;
               break;
          end;
     end;
end;

procedure TSkinForm.SetDisplayText(ID : string; Text : string);
var
   i : integer;
begin
     {$IFDEF DELPHI3}
     for i := 0 to FDisplayCount - 1 do
     {$ELSE}
     for i := 0 to Length(FDisplayInfoArray) - 1 do
     {$ENDIF}
     begin
          if FDisplayInfoArray[i].ID = ID then
          begin
               FDisplayInfoArray[i].Text := Text;
               break;
          end;
     end;
     Refresh;
end;

procedure TSkinForm.SetCharset(Charset : TFontCharset);
var
   i : integer;
begin
     FCharset := Charset;
     {$IFDEF DELPHI3}
     for i := 0 to FDisplayCount - 1 do
     {$ELSE}
     for i := 0 to Length(FDisplayInfoArray) - 1 do
     {$ENDIF}
     begin
          FDisplayInfoArray[i].Font.Charset := Charset;
     end;
     Refresh;
end;

function TSkinForm.GetTrackBarPos(ID : string) : integer;
var
   i : integer;
begin
     result := 0;
     {$IFDEF DELPHI3}
     for i := 0 to FTrackBarCount - 1 do
     {$ELSE}
     for i := 0 to Length(FTrackBarInfoArray) - 1 do
     {$ENDIF}
     begin
          if FTrackBarInfoArray[i].ID = ID then
          begin
               result := FTrackBarInfoArray[i].Position;
               break;
          end;
     end;
end;

procedure TSKinForm.SetTrackBarPos(ID : string; Value : integer);
var
   i : integer;
begin
     {$IFDEF DELPHI3}
     for i := 0 to FTrackBarCount - 1 do
     {$ELSE}
     for i := 0 to Length(FTrackBarInfoArray) - 1 do
     {$ENDIF}
     begin
          if FTrackBarInfoArray[i].ID = ID then
          begin
               FTrackBarInfoArray[i].Position := Value mod 101;
               if FTrackBarInfoArray[i].Direction = TRUE then
                  FTrackBarInfoArray[i].Offset := FTrackBarInfoArray[i].Position * (FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Width) div 100
               else
                   FTrackBarInfoArray[i].Offset := FTrackBarInfoArray[i].Position * (FTrackBarInfoArray[i].Length - FTrackBarInfoArray[i].Height) div 100;
               Refresh;
               break;
          end;
     end;
end;

function TSkinForm.GetSkinEditor : string;
begin
     result := 'Run Editor'
end;

procedure TSkinForm.SetSkinEditor(Value : string);
begin
     //do nothing
end;

procedure TSkinForm.JPEG2Bitmap(var Bitmap : TBitmap; const JPEGFileName : string);
var
   tempJPEG : TImage;
begin
     tempJPEG := TImage.Create(self);
     tempJPEG.Picture.LoadFromFile(JPEGFileName);
     if Bitmap = nil then Bitmap := TBitmap.Create;
     Bitmap.Width := tempJPEG.Picture.Width;
     Bitmap.Height := tempJPEG.Picture.Height;
     Bitmap.Canvas.Draw(0, 0, tempJPEG.Picture.Graphic);
     tempJPEG.Free;
end;

procedure TSkinForm.JPEG2BitmapRes(var Bitmap : TBitmap; const JPEGResName : string);
var
   tempJPEG : TJPEGImage;
   ResStream : TResourceStream;
begin
     tempJPEG := TJPEGImage.Create;
     ResStream := TResourceStream.Create(hInstance, JPEGResName, 'JPG');
     tempJPEG.LoadFromStream(ResStream);
     if Bitmap = nil then Bitmap := TBitmap.Create;
     Bitmap.Width := tempJPEG.Width;
     Bitmap.Height := tempJPEG.Height;
     Bitmap.Canvas.Draw(0, 0, tempJPEG);
     tempJPEG.Free;
     ResStream.Free;
end;

{$IFDEF GIFSUPPORT}
procedure TSkinForm.GIF2Bitmap(var Bitmap : TBitmap; const GIFFileName : string);
var
   tempGIF : TGifImage;
begin
     tempGIF := TGifImage.Create;
     tempGIF.LoadFromFile(GIFFileName);
     if Bitmap = nil then Bitmap := TBitmap.Create;
     Bitmap.Width := tempGIF.Width;
     Bitmap.Height := tempGIF.Height;
     Bitmap.Canvas.Draw(0, 0, tempGIF.Bitmap);
     tempGIF.Free;
end;

procedure TSkinForm.GIF2BitmapRes(var Bitmap : TBitmap; const GIFResName : string);
var
   tempGIF : TGifImage;
   ResStream : TResourceStream;
   Stream : TMemoryStream;
begin
     tempGIF := TGifImage.Create;
     ResStream := TResourceStream.Create(hInstance, GIFResName, 'GIF');
     Stream := TMemoryStream.Create;
     ResStream.SaveToStream(Stream);
     tempGIF.LoadFromStream(Stream);
     if Bitmap = nil then Bitmap := TBitmap.Create;
     Bitmap.Width := tempGIF.Width;
     Bitmap.Height := tempGIF.Height;
     Bitmap.Canvas.Draw(0, 0, tempGIF.Bitmap);
     tempGIF.Free;
     ResStream.Free;
     Stream.Free;
end;
{$ENDIF}

procedure TSkinForm.BMP2BitmapRes(var Bitmap : TBitmap; const BMPResName : string);
var
  tempBMP : TBitmap;
  ResStream : TResourceStream;
begin
     tempBMP := TBitmap.Create;
     ResStream := TResourceStream.Create(hInstance, BMPResName, 'BMP');
     tempBMP.LoadFromStream(ResStream);
     if Bitmap = nil then Bitmap := TBitmap.Create;
     Bitmap.Width := tempBMP.Width;
     Bitmap.Height := tempBMP.Height;
     Bitmap.Canvas.Draw(0, 0, tempBMP);
     tempBMP.Free;
     ResStream.Free;
end;

procedure TSkinForm.WriteNumbersString(X, Y : integer; const Str : string);
var
   Ch : Char;
   Index, Width, Height, Count, iLoop, Value : integer;
   Dest, Src : TRect;
begin
     Count := Length(Str);
     Width := FNumbersBitmap.Width div Length(NumbersString);
     Height := FNumbersBitmap.Height;
     for iLoop := 0 to Count - 1 do
     begin
          Ch := Str[iLoop + 1];
          Value := Pos(Ch, NumbersString);
          if Value <> 0 then index := Value - 1
          else index := 0;
          Src := Rect(index * Width, 0, (index+1) * Width, Height);
          Dest := Rect(X + iLoop * Width, Y, X + (iLoop + 1) * Width, Y + Height);
          Canvas.CopyRect(Dest, FNumbersBitmap.Canvas, Src);
     end;
end;

procedure TSkinForm.WriteTextString(X, Y : integer; const Str : string);
var
   Ch : Char;
   Col, Row, Width, Height, Count, iLoop : integer;
   Dest, Src : TRect;
begin
     Count := Length(Str);
     Width := FTextBitmap.Width div Length(TextStringRow1);
     Height := FTextBitmap.Height div 3;
     for iLoop := 0 to Count - 1 do
     begin
          Ch := Str[iLoop + 1];

          if Pos(Ch, TextStringRow1) <> 0 then
          begin
               Row:=0;
               Col:= Pos(Ch, TextStringRow1) - 1;
          end
          else
              if Pos(Ch,TextStringRow2) <> 0 then
              begin
                   Row:= 1;
                   Col:= Pos(Ch, TextStringRow2) - 1;
              end
              else
                  if Pos(Ch,TextStringRow3) <> 0 then
                  begin
                        Row:= 2;
                        Col:= Pos(Ch, TextStringRow3) - 1;
                  end
                  else
                      begin
                           Row := 1;
                           Col:= 10;
                      end;
          Src := Rect(Col * Width, Row * Height, (Col + 1) * Width, (Row + 1) * Height);
          Dest := Rect(X + iLoop * Width, Y, X + (iLoop + 1) * Width, Y + Height);
          Canvas.CopyRect(Dest, FTextBitmap.Canvas, Src);
     end;
end;

procedure TSkinForm.ShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
var
   LastHint : string;
begin
     with HintInfo do
     begin
          If HintControl = self then
          begin
               LastHint := HintStr;
               HintStr := Hint;
               {$IFDEF DELPHI3}
               if HintStr <> LastHint then CursorRect := Rect(0,0,0,0);
               {$ELSE}
               CursorRect := Rect(0,0,0,0);
               {$ENDIF}
          end;
     end;
end;

procedure TSkinForm.SetSkinFile(const Value : string);
begin
     if Value <> '' then FSkinFile := Value;
end;

procedure TSKinForm.SetTrackBarMinMax(ID : string; Min, Max : integer);
var
   i : integer;
   Temp : integer;
begin
     if Min > Max then
     begin
          Temp := Min;
          Min := Max;
          Max := Temp;
     end;

     if Min < 0 then Min := 0;
     if Max > 100 then Max := 100;

     {$IFDEF DELPHI3}
     for i := 0 to FTrackBarCount - 1 do
     {$ELSE}
     for i := 0 to Length(FTrackBarInfoArray) - 1 do
     {$ENDIF}
     begin
          if FTrackBarInfoArray[i].ID = ID then
          begin
               FTrackBarInfoArray[i].Min := Min;
               FTrackBarInfoArray[i].Max := Max;
               break;
          end;
     end;
end;

procedure TSkinForm.ValidateTrackBar(var Trackbar : TrackBarInfoRec);
begin
     with TrackBar do
     begin
          if Position < Min then Position := Min;
          if Position > Max then Position := Max;
          Position := Position mod 101;
          if Direction = TRUE then
             Offset := Position * (Length - Width) div 100
          else
              Offset := Position * (Length - Height) div 100;
     end;
end;

function  GetExtendName(str : string) : string;
var
   i : integer;
begin
     i := Pos('.', str);
     if i > 0 then Result := string(StrUpper(PChar(Copy(str, i+1, 3))))
     else Result := ' ';
end;

function GetName(str : string) : string;
var
   i : integer;
begin
     i := Pos('.', str);
     if i > 0 then Result := string(StrUpper(PChar(Copy(str, 1, i - 1))))
     else Result := ' ';
end;

function MinByte(B1, B2: byte): byte;
begin
     if B1 < B2 then
        Result := B1
     else
         Result := B2;
end;

// This function programmed by Eddie Shipman
// And a little changed by Konrad Swart
function Bitmap2Region( hBmp: TBitmap; TransColor: TColor; Tolerance: TColor): HRGN;
const
  ALLOC_UNIT = 100;
var
  MemDC, DC: HDC;
  BitmapInfo: TBitmapInfo;
  hbm32, holdBmp, holdMemBmp: HBitmap;
  pbits32 : Pointer;
  bm32 : BITMAP;
  maxRects: DWORD;
  hData: HGLOBAL;
  pData: PRgnData;
  b, LR, LG, LB, HR, HG, HB: Byte;
  p32: pByte;
  x, x0, y: integer;
  p: pLongInt;
  pr: PRect;
  h: HRGN;
begin
  Result := 0;
  if hBmp <> nil then
  begin
    { Create a memory DC inside which we will scan the bitmap contents }
    MemDC := CreateCompatibleDC(0);
    if MemDC <> 0 then
    begin
     { Create a 32 bits depth bitmap and select it into the memory DC }
      with BitmapInfo.bmiHeader do
      begin
        biSize          := sizeof(TBitmapInfoHeader);
        biWidth         := hBmp.Width;
        biHeight        := hBmp.Height;
        biPlanes        := 1;
        biBitCount      := 32;
        biCompression   := BI_RGB; { (0) uncompressed format }
        biSizeImage     := 0;
        biXPelsPerMeter := 0;
        biYPelsPerMeter := 0;
        biClrUsed       := 0;
        biClrImportant  := 0;
      end;
      hbm32 := CreateDIBSection(MemDC, BitmapInfo, DIB_RGB_COLORS, pbits32,0, 0);
      if hbm32 <> 0 then
      begin
        holdMemBmp := SelectObject(MemDC, hbm32);
        {
          Get how many bytes per row we have for the bitmap bits
          (rounded up to 32 bits)
        }
        GetObject(hbm32, SizeOf(bm32), @bm32);
        while (bm32.bmWidthBytes mod 4) > 0 do
          inc(bm32.bmWidthBytes);
        DC := CreateCompatibleDC(MemDC);
        { Copy the bitmap into the memory DC }
        holdBmp := SelectObject(DC, hBmp.Handle);
        BitBlt(MemDC, 0, 0, hBmp.Width, hBmp.Height, DC, 0, 0, SRCCOPY);
        {
          For better performances, we will use the ExtCreateRegion() function
          to create the region. This function take a RGNDATA structure on
          entry. We will add rectangles by
          amount of ALLOC_UNIT number in this structure
        }
        maxRects := ALLOC_UNIT;
        hData := GlobalAlloc(GMEM_MOVEABLE, sizeof(TRgnDataHeader) +
           SizeOf(TRect) * maxRects);
        pData := GlobalLock(hData);
        pData^.rdh.dwSize := SizeOf(TRgnDataHeader);
        pData^.rdh.iType := RDH_RECTANGLES;
        pData^.rdh.nCount := 0;
        pData^.rdh.nRgnSize := 0;
        SetRect(pData^.rdh.rcBound, MaxInt, MaxInt, 0, 0);
        { Keep on hand highest and lowest values for the "transparent" pixel }
        LR := GetRValue(ColorToRGB(TransColor));
        LG := GetGValue(ColorToRGB(TransColor));
        LB := GetBValue(ColorToRGB(TransColor));
        { Add the value of the tolerance to the "transparent" pixel value }
        HR := MinByte($FF, LR + GetRValue(ColorToRGB(Tolerance)));
        HG := MinByte($FF, LG + GetGValue(ColorToRGB(Tolerance)));
        HB := MinByte($FF, LB + GetBValue(ColorToRGB(Tolerance)));
        {
          Scan each bitmap row from bottom to top,
          the bitmap is inverted vertically
        }
        p32 := bm32.bmBits;
        inc(PChar(p32), (bm32.bmHeight - 1) * bm32.bmWidthBytes);
        for y := 0 to hBmp.Height-1 do
        begin
          { Scan each bitmap pixel from left to right }
          x := -1;
          while x+1 < hBmp.Width do
          begin
            inc(x);
            { Search for a continuous range of "non transparent pixels" }
            x0 := x;
            p := PLongInt(p32);
            inc(PChar(p), x * SizeOf(LongInt));
            while x < hBmp.Width do
            begin
              b := GetBValue(p^);                 // Changed from GetRValue(p^)
              if (b >= LR) and (b <= HR) then
              begin
                b := GetGValue(p^);               // Left alone
                if (b >= LG) and (b <= HG) then
                begin
                  b := GetRValue(p^);             // Changed from GetBValue(p^)
                  if (b >= LB) and (b <= hb) then
                    { This pixel is "transparent" }
                    break;
                end;
              end;
              inc(PChar(p), SizeOf(LongInt));
              inc(x);
            end;
            if x > x0 then
            begin
              {
                Add the pixels (x0, y) to (x, y+1) as a new rectangle in
                the region
              }
              if pData^.rdh.nCount >= maxRects then
              begin
                GlobalUnlock(hData);
                inc(maxRects, ALLOC_UNIT);
                hData := GlobalReAlloc(hData, SizeOf(TRgnDataHeader) +
                   SizeOf(TRect) * maxRects, GMEM_MOVEABLE);
                pData := GlobalLock(hData);
                Assert(pData <> NIL);
              end;
//              Modified by Konrad Swart
//              pr := @pData^.Buffer[pData^.rdh.nCount * SizeOf(TRect)];
                pr := PRect(@pData^.Buffer[pData^.rdh.nCount * SizeOf(TRect)]);
              SetRect(pr^, x0, y, x, y+1);
              if x0 < pData^.rdh.rcBound.Left then
                pData^.rdh.rcBound.Left := x0;
              if y < pData^.rdh.rcBound.Top then
                pData^.rdh.rcBound.Top := y;
              if x > pData^.rdh.rcBound.Right then
                pData^.rdh.rcBound.Left := x;
              if y+1 > pData^.rdh.rcBound.Bottom then
                pData^.rdh.rcBound.Bottom := y+1;
              inc(pData^.rdh.nCount);
              {
               On Windows98, ExtCreateRegion() may fail if the number of
               rectangles is too large (ie: > 4000). Therefore, we have to
               create the region by multiple steps
              }
              if pData^.rdh.nCount = 2000 then
              begin
                h := ExtCreateRegion(NIL, SizeOf(TRgnDataHeader) +
                   (SizeOf(TRect) * maxRects), pData^);
                Assert(h <> 0);
                if Result <> 0 then
                begin
                  CombineRgn(Result, Result, h, RGN_OR);
                  DeleteObject(h);
                end else
                  Result := h;
                pData^.rdh.nCount := 0;
                SetRect(pData^.rdh.rcBound, MaxInt, MaxInt, 0, 0);
              end;
            end;
          end;
          {
            Go to next row (remember, the bitmap is inverted vertically)
            that is why we use DEC!
          }
          Dec(PChar(p32), bm32.bmWidthBytes);
        end;
        { Create or extend the region with the remaining rectangle }
        h := ExtCreateRegion(NIL, SizeOf(TRgnDataHeader) +
           (SizeOf(TRect) * maxRects), pData^);
        Assert(h <> 0);
        if Result <> 0 then
        begin
          CombineRgn(Result, Result, h, RGN_OR);
          DeleteObject(h);
        end else
          Result := h;
        { Clean up }
        GlobalFree(hData);
        SelectObject(DC, holdBmp);
        DeleteDC(DC);
        DeleteObject(SelectObject(MemDC, holdMemBmp));
      end;
    end;
    DeleteDC(MemDC);
  end;
end;


// This function programmed by jscalco@idealsw.com
procedure CommaTextToStrs( AStrs: TStrings;
                           const Value: string ;
                           const AchDelim : Char );
var
  P, P1     : PChar;
  S         : string;
  chDelim   : char ;
begin
    chDelim := AchDelim ;
    AStrs.BeginUpdate;
    try
      AStrs.Clear;
      P := PChar(Value);

      while P^ in [#1..' '] do
            P := CharNext(P);

      while P^ <> #0 do
         begin
           if ( P^ = '"' ) then
                 S := AnsiExtractQuotedStr(P, '"')
           else
             begin
                  P1 := P;
                  while (P^ >= ' ') and ( P^ <> chDelim ) do
                        P := CharNext(P);

                  SetString(S, P1, P - P1);
             end;

           AStrs.Add(S);

           while P^ in [#1..' '] do
                 P := CharNext(P);

           if P^ = chDelim then // P^ = ',' then
              repeat
                 P := CharNext(P);
              until not (P^ in [#1..' ']);

         end;  // while

    finally
      AStrs.EndUpdate;
    end;
end;

procedure Register;
begin
  RegisterComponents('My Favorites', [TSkinForm]);
  RegisterPropertyEditor(TypeInfo(String), TSkinForm, 'SkinEditor', TSkinEditorProperty);
  RegisterPropertyEditor(TypeInfo(String), TSkinForm, 'SkinFile', TSkinFilenameProperty);
  RegisterComponentEditor(TSkinForm, TSkinFormComponentEditor);
end;
{

105-0004

Tokyo Bijyutsu Club Bldg 6F, 6-19-15 Shinbashi, Minato-ku , Tokyo, Japan

Xue Huai Qing [xhq@writeme.com]


}
end.



